// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TokenParser.java

package oracle.gss.util.CharConvBuilder;

import java.io.*;

public class TokenParser
{

    public TokenParser()
    {
    }

    static int getInteger(StreamTokenizer streamtokenizer)
        throws IOException
    {
        if(streamtokenizer.ttype != -2)
            throw new NumberFormatException();
        if(streamtokenizer.nval != 0.0D)
            return (int)streamtokenizer.nval;
        int i = streamtokenizer.nextToken();
        if(i == -3)
            return hexToInt(streamtokenizer.sval);
        else
            throw new NumberFormatException();
    }

    static long getLong(StreamTokenizer streamtokenizer)
        throws IOException
    {
        if(streamtokenizer.ttype != -2)
            throw new NumberFormatException();
        if(streamtokenizer.nval != 0.0D)
            return (long)streamtokenizer.nval;
        int i = streamtokenizer.nextToken();
        if(i == -3)
            return hexToLong(streamtokenizer.sval);
        else
            throw new NumberFormatException();
    }

    static String getString(StreamTokenizer streamtokenizer, int i)
        throws IOException
    {
        if(streamtokenizer.ttype == i || streamtokenizer.ttype == -1 || streamtokenizer.ttype == 10)
            return "";
        String s;
        int j;
        for(s = streamtokenizer.sval; (j = streamtokenizer.nextToken()) != -1 && j != 10 && j != i; s = s + streamtokenizer.sval);
        return s;
    }

    static StreamTokenizer getTokenizer(FileInputStream fileinputstream)
    {
        StreamTokenizer streamtokenizer = new StreamTokenizer(new BufferedReader(new InputStreamReader(fileinputstream)));
        streamtokenizer.commentChar(35);
        streamtokenizer.lowerCaseMode(true);
        streamtokenizer.quoteChar(34);
        return streamtokenizer;
    }

    static final int hexToInt(String s)
        throws NumberFormatException
    {
        s.toLowerCase();
        if(s.length() < 2 || s.indexOf('x') != 0)
            throw new NumberFormatException();
        else
            return Integer.parseInt(s.substring(1), 16);
    }

    static final long hexToLong(String s)
        throws NumberFormatException
    {
        s.toLowerCase();
        if(s.length() < 2 || s.indexOf('x') != 0)
            throw new NumberFormatException();
        else
            return Long.parseLong(s.substring(1), 16);
    }

    static String intToHex(int i)
    {
        String s = "0x000";
        String s1 = Integer.toHexString(i);
        return "0x000".substring(0, 6 - s1.length()) + s1;
    }

    static final void printToken(StreamTokenizer streamtokenizer, int i)
    {
        switch(i)
        {
        case -3: 
            System.err.println(streamtokenizer.sval);
            break;

        case -2: 
            System.err.println("Number " + streamtokenizer.nval);
            break;

        case 10: // '\n'
            System.err.println("End of line");
            break;

        default:
            System.err.println("Unknown token " + (char)i);
            break;
        }
    }

    static final int processSyntaxError(StreamTokenizer streamtokenizer, int i)
        throws IOException
    {
        System.err.println("Syntax error at line " + streamtokenizer.lineno());
        skipToEndOfDelimiter(streamtokenizer, i);
        return 0;
    }

    static final boolean searchKeyword(String s, StreamTokenizer streamtokenizer)
        throws IOException
    {
        boolean flag = false;
        String s1 = "";
        int i;
        while((i = streamtokenizer.nextToken()) != -1) 
        {
            if(i == -3)
            {
                String s2 = "";
                s2 = s2 + streamtokenizer.sval;
                if(s2.equals(s))
                    return true;
            }
            skipToEol(streamtokenizer);
        }
        return false;
    }

    static final void skipToCloseBrace(StreamTokenizer streamtokenizer)
        throws IOException
    {
        int j = 1;
        int i;
        while((i = streamtokenizer.nextToken()) != -1) 
            switch(i)
            {
            case 124: // '|'
            default:
                break;

            case 123: // '{'
                j++;
                break;

            case 125: // '}'
                if(--j < 1)
                    return;
                break;
            }
    }

    static final void skipToEndOfDelimiter(StreamTokenizer streamtokenizer, int i)
        throws IOException
    {
        if(i == 2)
            skipToCloseBrace(streamtokenizer);
        else
            skipToEol(streamtokenizer);
    }

    static final void skipToEol(StreamTokenizer streamtokenizer)
        throws IOException
    {
        streamtokenizer.eolIsSignificant(true);
        int i;
        while((i = streamtokenizer.nextToken()) != 10 && i != -1) ;
        streamtokenizer.eolIsSignificant(false);
    }

    static final String NAME = "name";
    static final String ID = "id";
    static final String FLAGS = "flags";
    static final String BASECHAR = "base_char_set";
    static final String REPLACEMENTCHAR = "default_replacement_char";
    static final String MBREPLACEMENTCHAR = "default_multibyte_replacement_char";
    static final String CHARACTERDATA = "character_data";
    static final String XTRAUNICODEMAPPING = "replacement_chars";
    static final String MULTIBYTEEQUIVALENT = "multi_byte_equivalent";
    static final int ST_UNKNOWN = -1;
    static final int ST_BEGIN = 0;
    static final int ST_STRING = 1;
    static final int ST_STRINGCONNECTION = 2;
    static final int ST_EQUALSIGN = 3;
    static final int ST_HEXZERO0 = 4;
    static final int ST_HEXNUMBER0 = 5;
    static final int ST_BEGINMAPPING = 6;
    static final int ST_OPENBRACE = 6;
    static final int ST_HEXZERO1 = 7;
    static final int ST_HEXNUMBER1 = 8;
    static final int ST_MAPSEPARATOR = 9;
    static final int ST_HEXZERO2 = 10;
    static final int ST_HEXNUMBER2 = 11;
    static final int ST_PAIRSEPARATOR = 12;
    static final int ST_ENDMAPPING = 13;
    static final int ST_ENDBRACE = 13;
    static final int ST_HAVESOURCECP = 14;
    static final int ST_HAVETARGETCP = 15;
    static final int DT_LINE = 1;
    static final int DT_BRACE = 2;
}
