// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleBlobInputStream.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            OracleBufferedStream, OracleConnection

public class OracleBlobInputStream extends OracleBufferedStream
{

    public OracleBlobInputStream(BLOB blob)
        throws SQLException
    {
        this(blob, blob.getConnection().db_access.getDefaultStreamChunkSize(), 1L);
    }

    public OracleBlobInputStream(BLOB blob, int i)
        throws SQLException
    {
        this(blob, i, 1L);
    }

    public OracleBlobInputStream(BLOB blob, int i, long l)
        throws SQLException
    {
        super(i);
        endOfStream = false;
        if(blob == null || i <= 0 || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            lob = blob;
            markedByte = -1L;
            lob_offset = l;
            return;
        }
    }

    public OracleBlobInputStream(BFILE bfile)
        throws SQLException
    {
        this(bfile, bfile.getConnection().db_access.getDefaultStreamChunkSize(), 1L);
    }

    public OracleBlobInputStream(BFILE bfile, int i)
        throws SQLException
    {
        this(bfile, i, 1L);
    }

    public OracleBlobInputStream(BFILE bfile, int i, long l)
        throws SQLException
    {
        super(i);
        endOfStream = false;
        if(bfile == null || i <= 0 || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            lob = bfile;
            markedByte = -1L;
            lob_offset = l;
            return;
        }
    }

    public boolean needBytes()
        throws IOException
    {
        ensureOpen();
        if(pos >= count)
        {
            if(!endOfStream)
                try
                {
                    if(lob instanceof BLOB)
                        count = ((BLOB)lob).getBytes(lob_offset, chunkSize, buf);
                    else
                        count = ((BFILE)lob).getBytes(lob_offset, chunkSize, buf);
                    if(count < chunkSize)
                        endOfStream = true;
                    if(count > 0)
                    {
                        pos = 0;
                        lob_offset += count;
                        return true;
                    }
                }
                catch(SQLException sqlexception)
                {
                    DBError.SQLToIOException(sqlexception);
                }
            return false;
        } else
        {
            return true;
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(closed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    public boolean markSupported()
    {
        return true;
    }

    public synchronized void mark(int i)
    {
        if(i < 0)
        {
            throw new IllegalArgumentException("Read-ahead limit < 0");
        } else
        {
            markedByte = (lob_offset - (long)count) + (long)pos;
            return;
        }
    }

    public synchronized void reset()
        throws IOException
    {
        ensureOpen();
        if(markedByte < 0L)
        {
            throw new IOException("Mark invalid or stream not marked.");
        } else
        {
            lob_offset = markedByte;
            pos = count;
            endOfStream = false;
            return;
        }
    }

    public long skip(long l)
        throws IOException
    {
        ensureOpen();
        long l1 = 0L;
        if((long)(count - pos) >= l)
        {
            pos += l;
            l1 += l;
        } else
        {
            l1 += count - pos;
            pos = count;
            try
            {
                long l2 = 0L;
                if(lob instanceof BLOB)
                    l2 = (((BLOB)lob).length() - lob_offset) + 1L;
                else
                    l2 = (((BFILE)lob).length() - lob_offset) + 1L;
                if(l2 >= l - l1)
                {
                    lob_offset += l - l1;
                    l1 += l - l1;
                } else
                {
                    lob_offset += l2;
                    l1 += l2;
                }
            }
            catch(SQLException sqlexception)
            {
                DBError.SQLToIOException(sqlexception);
            }
        }
        return l1;
    }

    long lob_offset;
    Datum lob;
    long markedByte;
    boolean endOfStream;
}
