// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleClobOutputStream.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.OutputStream;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.sql.CLOB;

// Referenced classes of package oracle.jdbc.driver:
//            OracleConnection

public class OracleClobOutputStream extends OutputStream
{

    public OracleClobOutputStream(CLOB clob)
        throws SQLException
    {
        this(clob, clob.getConnection().db_access.getDefaultStreamChunkSize(), 1L);
    }

    public OracleClobOutputStream(CLOB clob, int i)
        throws SQLException
    {
        this(clob, i, 1L);
    }

    public OracleClobOutputStream(CLOB clob, int i, long l)
        throws SQLException
    {
        if(clob == null || i <= 0 || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            m_clob = clob;
            m_lobOffset = l;
            m_buf = new byte[i];
            m_count = 0;
            m_bufSize = i;
            m_isClosed = false;
            return;
        }
    }

    public void write(int i)
        throws IOException
    {
        ensureOpen();
        if(m_count >= m_buf.length)
            flushBuffer();
        m_buf[m_count++] = (byte)i;
    }

    public void write(byte abyte0[], int i, int j)
        throws IOException
    {
        ensureOpen();
        int k = i;
        for(int l = k + Math.min(j, abyte0.length - i); k < l;)
        {
            int i1 = Math.min(m_bufSize - m_count, l - k);
            System.arraycopy(abyte0, k, m_buf, m_count, i1);
            k += i1;
            m_count += i1;
            if(m_count >= m_bufSize)
                flushBuffer();
        }

    }

    public void flush()
        throws IOException
    {
        ensureOpen();
        flushBuffer();
    }

    public void close()
        throws IOException
    {
        flushBuffer();
        m_isClosed = true;
    }

    private void flushBuffer()
        throws IOException
    {
        try
        {
            if(m_count > 0)
            {
                char ac[] = new char[m_count];
                for(int i = 0; i < m_count; i++)
                    ac[i] = (char)m_buf[i];

                m_lobOffset += m_clob.putChars(m_lobOffset, ac);
                m_count = 0;
            }
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(m_isClosed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    long m_lobOffset;
    CLOB m_clob;
    byte m_buf[];
    int m_count;
    int m_bufSize;
    boolean m_isClosed;
}
