// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   UpdatableResultSet.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.jdbc.dbaccess.*;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, OracleConnection, OracleStatement, OracleResultSetMetaData, 
//            OracleResultSetImpl, ScrollableResultSet, OraclePreparedStatement, ScrollRsetStatement, 
//            OracleResultSet

public class UpdatableResultSet extends BaseResultSet
{

    public UpdatableResultSet(ScrollRsetStatement scrollrsetstatement, ScrollableResultSet scrollableresultset, int i, int j)
        throws SQLException
    {
        init(scrollrsetstatement, scrollableresultset, i, j);
        scrollableresultset.resetBeginColumnIndex();
        m_isCachedRset = true;
    }

    public UpdatableResultSet(ScrollRsetStatement scrollrsetstatement, OracleResultSetImpl oracleresultsetimpl, int i, int j)
        throws SQLException
    {
        init(scrollrsetstatement, oracleresultsetimpl, i, j);
        m_isCachedRset = false;
    }

    private void init(ScrollRsetStatement scrollrsetstatement, OracleResultSet oracleresultset, int i, int j)
        throws SQLException
    {
        if(scrollrsetstatement == null || oracleresultset == null || j != 1008)
            DBError.throwSqlException(68);
        m_conn = (OracleConnection)scrollrsetstatement.getConnection();
        m_rset = oracleresultset;
        m_scrollStmt = scrollrsetstatement;
        m_type = i;
        m_autoRefetch = scrollrsetstatement.getAutoRefetch();
        m_deleteStmt = null;
        m_insertStmt = null;
        m_updateSql1 = null;
        m_updateSql2 = null;
        m_updateStmt = null;
        m_idxColsChanged = null;
        m_rowBuffer = null;
        m_nullIndicator = null;
        m_typeInfo = null;
        m_isInserting = false;
        m_isUpdating = false;
        m_wasNull = -1;
        m_metadata = null;
        m_columnCount = 0;
    }

    public synchronized void close()
        throws SQLException
    {
        if(m_rset != null)
            m_rset.close();
        if(m_insertStmt != null)
            m_insertStmt.close();
        if(m_updateStmt != null)
            m_updateStmt.close();
        if(m_deleteStmt != null)
            m_deleteStmt.close();
        if(m_scrollStmt != null)
            m_scrollStmt.notify_close_rset();
        cancelRowInserts();
        m_conn = null;
        m_rset = null;
        m_scrollStmt = null;
        m_metadata = null;
        m_scrollStmt = null;
        m_deleteStmt = null;
        m_insertStmt = null;
        m_updateSql1 = null;
        m_updateSql2 = null;
        m_updateStmt = null;
        m_idxColsChanged = null;
        m_rowBuffer = null;
        m_nullIndicator = null;
        m_typeInfo = null;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        switch(m_wasNull)
        {
        case 1: // '\001'
            return true;

        case 2: // '\002'
            return false;

        case 4: // '\004'
            return m_rset.wasNull();

        case 3: // '\003'
        default:
            DBError.throwSqlException(24);
            break;
        }
        return false;
    }

    public int getFirstUserColumnIndex()
    {
        return 1;
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return (Statement)m_scrollStmt;
    }

    public SQLWarning getWarnings()
        throws SQLException
    {
        SQLWarning sqlwarning = m_rset.getWarnings();
        if(m_warning == null)
            return sqlwarning;
        SQLWarning sqlwarning1;
        for(sqlwarning1 = m_warning; sqlwarning1.getNextWarning() != null; sqlwarning1 = sqlwarning1.getNextWarning());
        sqlwarning1.setNextWarning(sqlwarning);
        return m_warning;
    }

    public void clearWarnings()
        throws SQLException
    {
        m_warning = null;
        m_rset.clearWarnings();
    }

    public synchronized boolean next()
        throws SQLException
    {
        cancelRowChanges();
        return m_rset.next();
    }

    public synchronized boolean isBeforeFirst()
        throws SQLException
    {
        return m_rset.isBeforeFirst();
    }

    public synchronized boolean isAfterLast()
        throws SQLException
    {
        return m_rset.isAfterLast();
    }

    public synchronized boolean isFirst()
        throws SQLException
    {
        return m_rset.isFirst();
    }

    public synchronized boolean isLast()
        throws SQLException
    {
        return m_rset.isLast();
    }

    public synchronized void beforeFirst()
        throws SQLException
    {
        cancelRowChanges();
        m_rset.beforeFirst();
    }

    public synchronized void afterLast()
        throws SQLException
    {
        cancelRowChanges();
        m_rset.afterLast();
    }

    public synchronized boolean first()
        throws SQLException
    {
        cancelRowChanges();
        return m_rset.first();
    }

    public synchronized boolean last()
        throws SQLException
    {
        cancelRowChanges();
        return m_rset.last();
    }

    public synchronized int getRow()
        throws SQLException
    {
        return m_rset.getRow();
    }

    public synchronized boolean absolute(int i)
        throws SQLException
    {
        cancelRowChanges();
        return m_rset.absolute(i);
    }

    public synchronized boolean relative(int i)
        throws SQLException
    {
        cancelRowChanges();
        return m_rset.relative(i);
    }

    public synchronized boolean previous()
        throws SQLException
    {
        cancelRowChanges();
        return m_rset.previous();
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        Datum datum = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            setIsNull(datum == null);
            datum = getRowBufferDatumAt(i);
        } else
        {
            setIsNull(4);
            datum = m_rset.getOracleObject(i + 1);
        }
        return datum;
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        String s = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                s = datum.stringValue();
        } else
        {
            setIsNull(4);
            s = m_rset.getString(i + 1);
        }
        return s;
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        boolean flag = false;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                flag = datum.booleanValue();
        } else
        {
            setIsNull(4);
            flag = m_rset.getBoolean(i + 1);
        }
        return flag;
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        byte byte0 = 0;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                byte0 = datum.byteValue();
        } else
        {
            setIsNull(4);
            byte0 = m_rset.getByte(i + 1);
        }
        return byte0;
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        short word0 = 0;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            long l = getLong(i);
            if(l > 0x10001L || l < 0xfffffffffffefffeL)
                DBError.check_error(26, "getShort");
            word0 = (short)(int)l;
        } else
        {
            setIsNull(4);
            word0 = m_rset.getShort(i + 1);
        }
        return word0;
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        int j = 0;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                j = datum.intValue();
        } else
        {
            setIsNull(4);
            j = m_rset.getInt(i + 1);
        }
        return j;
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        long l = 0L;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                l = datum.longValue();
        } else
        {
            setIsNull(4);
            l = m_rset.getLong(i + 1);
        }
        return l;
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        float f = 0.0F;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                f = datum.floatValue();
        } else
        {
            setIsNull(4);
            f = m_rset.getFloat(i + 1);
        }
        return f;
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        double d = 0.0D;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                d = datum.doubleValue();
        } else
        {
            setIsNull(4);
            d = m_rset.getDouble(i + 1);
        }
        return d;
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        BigDecimal bigdecimal = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                bigdecimal = datum.bigDecimalValue();
        } else
        {
            setIsNull(4);
            bigdecimal = m_rset.getBigDecimal(i + 1);
        }
        return bigdecimal;
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        byte abyte0[] = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                abyte0 = datum.getBytes();
        } else
        {
            setIsNull(4);
            abyte0 = m_rset.getBytes(i + 1);
        }
        return abyte0;
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        Date date = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                date = datum.dateValue();
        } else
        {
            setIsNull(4);
            date = m_rset.getDate(i + 1);
        }
        return date;
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        Time time = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                time = datum.timeValue();
        } else
        {
            setIsNull(4);
            time = m_rset.getTime(i + 1);
        }
        return time;
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        Timestamp timestamp = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                timestamp = datum.timestampValue();
        } else
        {
            setIsNull(4);
            timestamp = m_rset.getTimestamp(i + 1);
        }
        return timestamp;
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        InputStream inputstream = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof InputStream)
                {
                    inputstream = (InputStream)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    inputstream = datum.asciiStreamValue();
                }
        } else
        {
            setIsNull(4);
            inputstream = m_rset.getAsciiStream(i + 1);
        }
        return inputstream;
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        InputStream inputstream = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof InputStream)
                {
                    inputstream = (InputStream)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    DBConversion dbconversion = m_conn.conversion;
                    byte abyte0[] = datum.shareBytes();
                    if(datum instanceof RAW)
                        inputstream = dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 3);
                    else
                    if(datum instanceof CHAR)
                        inputstream = dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 1);
                    else
                        DBError.check_error(4, "getUnicodeStream");
                }
        } else
        {
            setIsNull(4);
            inputstream = m_rset.getUnicodeStream(i + 1);
        }
        return inputstream;
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        InputStream inputstream = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof InputStream)
                {
                    inputstream = (InputStream)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    inputstream = datum.binaryStreamValue();
                }
        } else
        {
            setIsNull(4);
            inputstream = m_rset.getBinaryStream(i + 1);
        }
        return inputstream;
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        Object obj = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                obj = datum.toJdbc();
        } else
        {
            setIsNull(4);
            obj = m_rset.getObject(i + 1);
        }
        return obj;
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        Reader reader = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof Reader)
                {
                    reader = (Reader)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    reader = datum.characterStreamValue();
                }
        } else
        {
            setIsNull(4);
            reader = m_rset.getCharacterStream(i + 1);
        }
        return reader;
    }

    public synchronized BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        BigDecimal bigdecimal = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                bigdecimal = datum.bigDecimalValue();
        } else
        {
            setIsNull(4);
            bigdecimal = m_rset.getBigDecimal(i + 1);
        }
        return bigdecimal;
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        Object obj = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof STRUCT)
                    obj = ((STRUCT)datum).toJdbc(map);
                else
                    obj = datum.toJdbc();
        } else
        {
            setIsNull(4);
            obj = m_rset.getObject(i + 1, map);
        }
        return obj;
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        Date date = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof DATE)
                {
                    date = ((DATE)datum).dateValue(calendar);
                } else
                {
                    DATE date1 = new DATE(datum.stringValue());
                    if(date1 != null)
                        date = date1.dateValue(calendar);
                }
        } else
        {
            setIsNull(4);
            date = m_rset.getDate(i + 1, calendar);
        }
        return date;
    }

    public synchronized Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        Time time = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof DATE)
                {
                    time = ((DATE)datum).timeValue(calendar);
                } else
                {
                    DATE date = new DATE(datum.stringValue());
                    if(date != null)
                        time = date.timeValue(calendar);
                }
        } else
        {
            setIsNull(4);
            time = m_rset.getTime(i + 1, calendar);
        }
        return time;
    }

    public synchronized Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        Timestamp timestamp = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof DATE)
                {
                    timestamp = ((DATE)datum).timestampValue(calendar);
                } else
                {
                    DATE date = new DATE(datum.stringValue());
                    if(date != null)
                        timestamp = date.timestampValue(calendar);
                }
        } else
        {
            setIsNull(4);
            timestamp = m_rset.getTimestamp(i + 1, calendar);
        }
        return timestamp;
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        ResultSet resultset = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            DBError.check_error(4, "getCursor");
        } else
        {
            setIsNull(4);
            resultset = m_rset.getCursor(i + 1);
        }
        return resultset;
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        ROWID rowid = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof ROWID))
                DBError.check_error(4, "getROWID");
            rowid = (ROWID)datum;
        } else
        {
            setIsNull(4);
            rowid = m_rset.getROWID(i + 1);
        }
        return rowid;
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        NUMBER number = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof NUMBER))
                DBError.check_error(4, "getNUMBER");
            number = (NUMBER)datum;
        } else
        {
            setIsNull(4);
            number = m_rset.getNUMBER(i + 1);
        }
        return number;
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        DATE date = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof DATE))
                DBError.check_error(4, "getDATE");
            date = (DATE)datum;
        } else
        {
            setIsNull(4);
            date = m_rset.getDATE(i + 1);
        }
        return date;
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        ARRAY array = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof ARRAY))
                DBError.check_error(4, "getARRAY");
            array = (ARRAY)datum;
        } else
        {
            setIsNull(4);
            array = m_rset.getARRAY(i + 1);
        }
        return array;
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        STRUCT struct = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof STRUCT))
                DBError.check_error(4, "getSTRUCT");
            struct = (STRUCT)datum;
        } else
        {
            setIsNull(4);
            struct = m_rset.getSTRUCT(i + 1);
        }
        return struct;
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        OPAQUE opaque = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof OPAQUE))
                DBError.check_error(4, "getOPAQUE");
            opaque = (OPAQUE)datum;
        } else
        {
            setIsNull(4);
            opaque = m_rset.getOPAQUE(i + 1);
        }
        return opaque;
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        REF ref = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof REF))
                DBError.check_error(4, "getREF");
            ref = (REF)datum;
        } else
        {
            setIsNull(4);
            ref = m_rset.getREF(i + 1);
        }
        return ref;
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        CHAR char1 = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof CHAR))
                DBError.check_error(4, "getCHAR");
            char1 = (CHAR)datum;
        } else
        {
            setIsNull(4);
            char1 = m_rset.getCHAR(i + 1);
        }
        return char1;
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        RAW raw = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof RAW))
                DBError.check_error(4, "getRAW");
            raw = (RAW)datum;
        } else
        {
            setIsNull(4);
            raw = m_rset.getRAW(i + 1);
        }
        return raw;
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        BLOB blob = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof BLOB))
                DBError.check_error(4, "getBLOB");
            blob = (BLOB)datum;
        } else
        {
            setIsNull(4);
            blob = m_rset.getBLOB(i + 1);
        }
        return blob;
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        CLOB clob = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof CLOB))
                DBError.check_error(4, "getCLOB");
            clob = (CLOB)datum;
        } else
        {
            setIsNull(4);
            clob = m_rset.getCLOB(i + 1);
        }
        return clob;
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        BFILE bfile = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof BFILE))
                DBError.check_error(4, "getBFILE");
            bfile = (BFILE)datum;
        } else
        {
            setIsNull(4);
            bfile = m_rset.getBFILE(i + 1);
        }
        return bfile;
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        if(customdatumfactory == null)
            DBError.throwSqlException(68);
        CustomDatum customdatum = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            customdatum = customdatumfactory.create(datum, 0);
        } else
        {
            setIsNull(4);
            customdatum = m_rset.getCustomDatum(i + 1, customdatumfactory);
        }
        return customdatum;
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        if(oradatafactory == null)
            DBError.throwSqlException(68);
        ORAData oradata = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            oradata = oradatafactory.create(datum, 0);
        } else
        {
            setIsNull(4);
            oradata = m_rset.getORAData(i + 1, oradatafactory);
        }
        return oradata;
    }

    public synchronized ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(((OracleStatement)m_scrollStmt).closed)
            DBError.check_error(9, "getMetaData");
        return new OracleResultSetMetaData(m_conn, (OracleStatement)m_scrollStmt, 1);
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        return m_rset.findColumn(s) - 1;
    }

    public synchronized void setFetchDirection(int i)
        throws SQLException
    {
        m_rset.setFetchDirection(i);
    }

    public synchronized int getFetchDirection()
        throws SQLException
    {
        return m_rset.getFetchDirection();
    }

    public synchronized void setFetchSize(int i)
        throws SQLException
    {
        m_rset.setFetchSize(i);
    }

    public synchronized int getFetchSize()
        throws SQLException
    {
        return m_rset.getFetchSize();
    }

    public int getType()
        throws SQLException
    {
        return m_type;
    }

    public int getConcurrency()
        throws SQLException
    {
        return 1008;
    }

    public boolean rowUpdated()
        throws SQLException
    {
        return false;
    }

    public boolean rowInserted()
        throws SQLException
    {
        return false;
    }

    public boolean rowDeleted()
        throws SQLException
    {
        return false;
    }

    public synchronized void insertRow()
        throws SQLException
    {
        if(!isOnInsertRow())
            DBError.throwSqlException(83);
        prepare_insertRow_statement();
        prepare_insertRow_binds();
        execute_insertRow();
    }

    public synchronized void updateRow()
        throws SQLException
    {
        if(isOnInsertRow())
            DBError.throwSqlException(84);
        int i = get_num_columns_changed();
        if(i > 0)
        {
            prepare_updateRow_statement(i);
            prepare_updateRow_binds(i);
            execute_updateRow();
        }
    }

    public synchronized void deleteRow()
        throws SQLException
    {
        if(isOnInsertRow())
            DBError.throwSqlException(84);
        prepare_deleteRow_statement();
        prepare_deleteRow_binds();
        execute_deleteRow();
    }

    public synchronized void refreshRow()
        throws SQLException
    {
        if(isOnInsertRow())
            DBError.throwSqlException(84);
        m_rset.refreshRow();
    }

    public synchronized void cancelRowUpdates()
        throws SQLException
    {
        if(m_isUpdating)
        {
            m_isUpdating = false;
            clearRowBuffer();
        }
    }

    public synchronized void moveToInsertRow()
        throws SQLException
    {
        if(isOnInsertRow())
            return;
        m_isInserting = true;
        if(m_rowBuffer == null)
            m_rowBuffer = new Object[getColumnCount()];
        if(m_nullIndicator == null)
            m_nullIndicator = new boolean[getColumnCount()];
        clearRowBuffer();
    }

    public synchronized void moveToCurrentRow()
        throws SQLException
    {
        cancelRowInserts();
    }

    public synchronized void updateString(int i, String s)
        throws SQLException
    {
        updateObject(i, s);
    }

    public synchronized void updateNull(int i)
        throws SQLException
    {
        setRowBufferAt(i, null);
    }

    public void updateBoolean(int i, boolean flag)
        throws SQLException
    {
        updateObject(i, new Boolean(flag));
    }

    public void updateByte(int i, byte byte0)
        throws SQLException
    {
        updateObject(i, new Integer(byte0));
    }

    public void updateShort(int i, short word0)
        throws SQLException
    {
        updateObject(i, new Integer(word0));
    }

    public void updateInt(int i, int j)
        throws SQLException
    {
        updateObject(i, new Integer(j));
    }

    public void updateLong(int i, long l)
        throws SQLException
    {
        updateObject(i, new Long(l));
    }

    public void updateFloat(int i, float f)
        throws SQLException
    {
        updateObject(i, new Float(f));
    }

    public void updateDouble(int i, double d)
        throws SQLException
    {
        updateObject(i, new Double(d));
    }

    public void updateBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        updateObject(i, bigdecimal);
    }

    public void updateBytes(int i, byte abyte0[])
        throws SQLException
    {
        updateObject(i, abyte0);
    }

    public void updateDate(int i, Date date)
        throws SQLException
    {
        updateObject(i, date);
    }

    public void updateTime(int i, Time time)
        throws SQLException
    {
        updateObject(i, time);
    }

    public void updateTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        updateObject(i, timestamp);
    }

    public void updateAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        if(inputstream != null && j > 0)
        {
            int k = 0;
            if(m_conn.conversion.isUcs2CharSet())
                k = _MIN_STREAM_SIZE / 2;
            else
                k = _MIN_STREAM_SIZE;
            if(j <= k)
            {
                byte abyte0[] = new byte[j];
                try
                {
                    int l = inputstream.read(abyte0);
                    inputstream.close();
                    String s = new String(abyte0, 0, l);
                    updateString(i, s);
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            } else
            {
                int ai[] = {
                    j, 1
                };
                setRowBufferAt(i, inputstream, ai);
            }
        } else
        {
            setRowBufferAt(i, null);
        }
    }

    public void updateBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        if(inputstream != null && j > 0)
        {
            int k = _MIN_STREAM_SIZE;
            if(j <= k)
            {
                byte abyte0[] = new byte[j];
                try
                {
                    int l = inputstream.read(abyte0);
                    inputstream.close();
                    updateBytes(i, abyte0);
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            } else
            {
                int ai[] = {
                    j, 2
                };
                setRowBufferAt(i, inputstream, ai);
            }
        } else
        {
            setRowBufferAt(i, null);
        }
    }

    public void updateCharacterStream(int i, Reader reader, int j)
        throws SQLException
    {
        if(reader != null && j > 0)
        {
            int k = 4000 / m_conn.db_access.getNlsRatio() / m_conn.conversion.getMaxCharbyteSize();
            if(j <= k)
            {
                char ac[] = new char[j];
                try
                {
                    int l = reader.read(ac);
                    reader.close();
                    updateString(i, new String(ac));
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            } else
            {
                int ai[] = {
                    j
                };
                setRowBufferAt(i, reader, ai);
            }
        } else
        {
            setRowBufferAt(i, null);
        }
    }

    public void updateObject(int i, Object obj, int j)
        throws SQLException
    {
        updateObject(i, obj);
    }

    public synchronized void updateObject(int i, Object obj)
        throws SQLException
    {
        Datum datum = null;
        if(obj != null)
            if(obj instanceof Datum)
                datum = (Datum)obj;
            else
                datum = SQLUtil.makeOracleDatum(m_conn, obj, getInternalMetadata().getColumnType(i + 1), null);
        setRowBufferAt(i, datum);
    }

    public synchronized void updateOracleObject(int i, Datum datum)
        throws SQLException
    {
        setRowBufferAt(i, datum);
    }

    public void updateROWID(int i, ROWID rowid)
        throws SQLException
    {
        updateOracleObject(i, rowid);
    }

    public void updateNUMBER(int i, NUMBER number)
        throws SQLException
    {
        updateOracleObject(i, number);
    }

    public void updateDATE(int i, DATE date)
        throws SQLException
    {
        updateOracleObject(i, date);
    }

    public void updateARRAY(int i, ARRAY array)
        throws SQLException
    {
        updateOracleObject(i, array);
    }

    public void updateSTRUCT(int i, STRUCT struct)
        throws SQLException
    {
        updateOracleObject(i, struct);
    }

    public void updateOPAQUE(int i, OPAQUE opaque)
        throws SQLException
    {
        updateOracleObject(i, opaque);
    }

    public void updateREF(int i, REF ref)
        throws SQLException
    {
        updateOracleObject(i, ref);
    }

    public void updateCHAR(int i, CHAR char1)
        throws SQLException
    {
        updateOracleObject(i, char1);
    }

    public void updateRAW(int i, RAW raw)
        throws SQLException
    {
        updateOracleObject(i, raw);
    }

    public void updateBLOB(int i, BLOB blob)
        throws SQLException
    {
        updateOracleObject(i, blob);
    }

    public void updateCLOB(int i, CLOB clob)
        throws SQLException
    {
        updateOracleObject(i, clob);
    }

    public void updateBFILE(int i, BFILE bfile)
        throws SQLException
    {
        updateOracleObject(i, bfile);
    }

    public void updateBfile(int i, BFILE bfile)
        throws SQLException
    {
        updateOracleObject(i, bfile);
    }

    public void updateCustomDatum(int i, CustomDatum customdatum)
        throws SQLException
    {
        Datum datum = customdatum.toDatum(m_conn);
        updateOracleObject(i, datum);
    }

    public void updateORAData(int i, ORAData oradata)
        throws SQLException
    {
        Datum datum = oradata.toDatum(m_conn);
        updateOracleObject(i, datum);
    }

    public void updateRef(int i, Ref ref)
        throws SQLException
    {
        updateREF(i, (REF)ref);
    }

    public void updateBlob(int i, Blob blob)
        throws SQLException
    {
        updateBLOB(i, (BLOB)blob);
    }

    public void updateClob(int i, Clob clob)
        throws SQLException
    {
        updateCLOB(i, (CLOB)clob);
    }

    public void updateArray(int i, Array array)
        throws SQLException
    {
        updateARRAY(i, (ARRAY)array);
    }

    private int getColumnCount()
        throws SQLException
    {
        if(m_columnCount == 0)
            if(m_rset instanceof OracleResultSetImpl)
            {
                if(((OracleResultSetImpl)m_rset).statement.defines != null)
                    m_columnCount = ((OracleResultSetImpl)m_rset).statement.defines.getNoOfArgs();
                else
                    m_columnCount = getInternalMetadata().getColumnCount();
            } else
            {
                m_columnCount = ((ScrollableResultSet)m_rset).getColumnCount();
            }
        return m_columnCount;
    }

    private ResultSetMetaData getInternalMetadata()
        throws SQLException
    {
        if(m_metadata == null)
            m_metadata = m_rset.getMetaData();
        return m_metadata;
    }

    private void cancelRowChanges()
        throws SQLException
    {
        if(m_isInserting)
            cancelRowInserts();
        if(m_isUpdating)
            cancelRowUpdates();
    }

    boolean isOnInsertRow()
    {
        return m_isInserting;
    }

    private void cancelRowInserts()
    {
        if(m_isInserting)
        {
            m_isInserting = false;
            clearRowBuffer();
        }
    }

    boolean isUpdatingRow()
    {
        return m_isUpdating;
    }

    private void clearRowBuffer()
    {
        if(m_rowBuffer != null)
        {
            for(int i = 0; i < m_rowBuffer.length; i++)
                m_rowBuffer[i] = null;

        }
        if(m_nullIndicator != null)
        {
            for(int j = 0; j < m_nullIndicator.length; j++)
                m_nullIndicator[j] = false;

        }
        if(m_typeInfo != null)
        {
            for(int k = 0; k < m_typeInfo.length; k++)
                if(m_typeInfo[k] != null)
                {
                    for(int l = 0; l < m_typeInfo[k].length; l++)
                        m_typeInfo[k][l] = 0;

                }

        }
    }

    private void setRowBufferAt(int i, Datum datum)
        throws SQLException
    {
        setRowBufferAt(i, datum, (int[])null);
    }

    private void setRowBufferAt(int i, Object obj, int ai[])
        throws SQLException
    {
        if(!m_isInserting)
            if(isBeforeFirst() || isAfterLast() || getRow() == 0)
                DBError.throwSqlException(82);
            else
                m_isUpdating = true;
        if(i < 1 || i > getColumnCount() - 1)
            DBError.throwSqlException(68, "setRowBufferAt");
        if(m_rowBuffer == null)
            m_rowBuffer = new Object[getColumnCount()];
        if(m_nullIndicator == null)
        {
            m_nullIndicator = new boolean[getColumnCount()];
            for(int j = 0; j < getColumnCount(); j++)
                m_nullIndicator[j] = false;

        }
        if(ai != null)
        {
            if(m_typeInfo == null)
                m_typeInfo = new int[getColumnCount()][];
            m_typeInfo[i] = ai;
        }
        m_rowBuffer[i] = obj;
        m_nullIndicator[i] = obj == null;
    }

    private Datum getRowBufferDatumAt(int i)
        throws SQLException
    {
        if(i < 1 || i > getColumnCount() - 1)
            DBError.throwSqlException(68, "getRowBufferDatumAt");
        Datum datum = null;
        if(m_rowBuffer != null)
        {
            Object obj = m_rowBuffer[i];
            if(obj != null)
                if(obj instanceof Datum)
                {
                    datum = (Datum)obj;
                } else
                {
                    datum = SQLUtil.makeOracleDatum(m_conn, obj, getInternalMetadata().getColumnType(i + 1), null);
                    m_rowBuffer[i] = datum;
                }
        }
        return datum;
    }

    private Object getRowBufferAt(int i)
        throws SQLException
    {
        if(i < 1 || i > getColumnCount() - 1)
            DBError.throwSqlException(68, "getRowBufferDatumAt");
        if(m_rowBuffer != null)
            return m_rowBuffer[i];
        else
            return null;
    }

    private boolean isRowBufferUpdatedAt(int i)
    {
        if(m_rowBuffer == null)
            return false;
        else
            return m_rowBuffer[i] != null || m_nullIndicator[i];
    }

    private void prepare_insertRow_statement()
        throws SQLException
    {
        if(m_insertStmt == null)
        {
            StringBuffer stringbuffer = new StringBuffer();
            stringbuffer.append("insert into (");
            stringbuffer.append(m_scrollStmt.getOriginalSql());
            stringbuffer.append(") values ( ");
            for(int i = 1; i < getColumnCount(); i++)
            {
                if(i != 1)
                    stringbuffer.append(", ");
                stringbuffer.append("?");
            }

            stringbuffer.append(")");
            m_insertStmt = (OraclePreparedStatement)m_conn.prepareStatement(stringbuffer.toString());
        }
    }

    private void prepare_insertRow_binds()
        throws SQLException
    {
        int i = 1;
        i = prepare_subquery_binds(m_insertStmt, i);
        for(int j = 1; j < getColumnCount(); j++)
        {
            Object obj = getRowBufferAt(j);
            if(obj != null)
            {
                if(obj instanceof Reader)
                    m_insertStmt.setCharacterStream((i + j) - 1, (Reader)obj, m_typeInfo[j][0]);
                else
                if(obj instanceof InputStream)
                {
                    if(m_typeInfo[j][1] == 2)
                        m_insertStmt.setBinaryStream((i + j) - 1, (InputStream)obj, m_typeInfo[j][0]);
                    else
                    if(m_typeInfo[j][1] == 1)
                        m_insertStmt.setAsciiStream((i + j) - 1, (InputStream)obj, m_typeInfo[j][0]);
                } else
                {
                    Datum datum = getRowBufferDatumAt(j);
                    m_insertStmt.setOracleObject((i + j) - 1, datum);
                }
            } else
            {
                int k = getInternalMetadata().getColumnType(j + 1);
                if(k == 2006 || k == 2002 || k == 2008 || k == 2007 || k == 2003)
                    m_insertStmt.setNull((i + j) - 1, k, getInternalMetadata().getColumnTypeName(j + 1));
                else
                    m_insertStmt.setNull((i + j) - 1, k);
            }
        }

    }

    private void execute_insertRow()
        throws SQLException
    {
        if(m_insertStmt.executeUpdate() != 1)
            DBError.throwSqlException(85);
    }

    private int get_num_columns_changed()
        throws SQLException
    {
        int i = 0;
        if(m_idxColsChanged == null)
            m_idxColsChanged = new int[getColumnCount()];
        if(m_rowBuffer != null)
        {
            for(int j = 1; j < getColumnCount(); j++)
                if(m_rowBuffer[j] != null || m_rowBuffer[j] == null && m_nullIndicator[j])
                    m_idxColsChanged[i++] = j;

        }
        return i;
    }

    private void prepare_updateRow_statement(int i)
        throws SQLException
    {
        if(m_updateStmt != null)
            m_updateStmt.close();
        StringBuffer stringbuffer = new StringBuffer();
        if(m_updateSql1 == null)
        {
            StringBuffer stringbuffer1 = new StringBuffer();
            stringbuffer1.append("update (");
            stringbuffer1.append(m_scrollStmt.getRevisedSql());
            stringbuffer1.append(") set ");
            m_updateSql1 = stringbuffer1.toString();
        }
        stringbuffer.append(m_updateSql1);
        if(m_rowBuffer != null)
        {
            for(int j = 0; j < i; j++)
            {
                if(j > 0)
                    stringbuffer.append(", ");
                stringbuffer.append(getInternalMetadata().getColumnName(m_idxColsChanged[j] + 1));
                stringbuffer.append(" = ? ");
            }

        }
        StringBuffer stringbuffer2 = new StringBuffer();
        if(m_updateSql2 == null)
        {
            stringbuffer2.append(" WHERE ");
            prepare_compare_self_sql(stringbuffer2);
            m_updateSql2 = stringbuffer2.toString();
        }
        stringbuffer.append(m_updateSql2);
        m_updateStmt = (OraclePreparedStatement)m_conn.prepareStatement(stringbuffer.toString());
    }

    private void prepare_updateRow_binds(int i)
        throws SQLException
    {
        int j = 1;
        j = prepare_subquery_binds(m_updateStmt, j);
        for(int k = 0; k < i; k++)
        {
            int l = m_idxColsChanged[k];
            Object obj = getRowBufferAt(l);
            if(obj != null)
            {
                if(obj instanceof Reader)
                    m_updateStmt.setCharacterStream(j++, (Reader)obj, m_typeInfo[l][0]);
                else
                if(obj instanceof InputStream)
                {
                    if(m_typeInfo[l][1] == 2)
                        m_updateStmt.setBinaryStream(j++, (InputStream)obj, m_typeInfo[l][0]);
                    else
                    if(m_typeInfo[l][1] == 1)
                        m_updateStmt.setAsciiStream(j++, (InputStream)obj, m_typeInfo[l][0]);
                } else
                {
                    Datum datum = getRowBufferDatumAt(l);
                    m_updateStmt.setOracleObject(j++, datum);
                }
            } else
            {
                int i1 = getInternalMetadata().getColumnType(l + 1);
                if(i1 == 2006 || i1 == 2002 || i1 == 2008 || i1 == 2007 || i1 == 2003)
                    m_updateStmt.setNull(j++, i1, getInternalMetadata().getColumnTypeName(l + 1));
                else
                    m_updateStmt.setNull(j++, i1);
            }
        }

        prepare_compare_self_binds(m_updateStmt, j);
    }

    private void execute_updateRow()
        throws SQLException
    {
        try
        {
            if(m_updateStmt.executeUpdate() == 0)
                DBError.throwSqlException(85);
            if(m_isCachedRset)
                if(m_autoRefetch)
                {
                    ((ScrollableResultSet)m_rset).refreshRowsInCache(getRow(), 1, 1000);
                    cancelRowUpdates();
                } else
                {
                    if(m_rowBuffer != null)
                    {
                        for(int i = 1; i < getColumnCount(); i++)
                            if(m_rowBuffer[i] != null || m_rowBuffer[i] == null && m_nullIndicator[i])
                                ((ScrollableResultSet)m_rset).setCurrentRowValueAt(this, i + 1, m_rowBuffer[i]);

                    }
                    cancelRowUpdates();
                }
        }
        finally
        {
            m_updateStmt.close();
            m_updateStmt = null;
        }
    }

    private void prepare_deleteRow_statement()
        throws SQLException
    {
        if(m_deleteStmt == null)
        {
            StringBuffer stringbuffer = new StringBuffer();
            stringbuffer.append("delete from (");
            stringbuffer.append(m_scrollStmt.getRevisedSql());
            stringbuffer.append(") where ");
            prepare_compare_self_sql(stringbuffer);
            m_deleteStmt = (OraclePreparedStatement)m_conn.prepareStatement(stringbuffer.toString());
        }
    }

    private void prepare_deleteRow_binds()
        throws SQLException
    {
        int i = 1;
        i = prepare_subquery_binds(m_deleteStmt, i);
        prepare_compare_self_binds(m_deleteStmt, i);
    }

    private void execute_deleteRow()
        throws SQLException
    {
        if(m_deleteStmt.executeUpdate() == 0)
            DBError.throwSqlException(85);
        if(m_isCachedRset)
            ((ScrollableResultSet)m_rset).removeRowInCache(getRow());
    }

    private void prepare_compare_self_sql(StringBuffer stringbuffer)
        throws SQLException
    {
        stringbuffer.append(" ROWID = ? ");
    }

    private int prepare_compare_self_binds(OraclePreparedStatement oraclepreparedstatement, int i)
        throws SQLException
    {
        Datum datum = m_rset.getOracleObject(1);
        oraclepreparedstatement.setOracleObject(i, m_rset.getOracleObject(1));
        return i + 1;
    }

    private int prepare_subquery_binds(OraclePreparedStatement oraclepreparedstatement, int i)
        throws SQLException
    {
        int j = i - 1;
        int k = 0;
        DBDataSet dbdataset = m_scrollStmt.getBinds();
        if(dbdataset != null)
        {
            k = dbdataset.getNoOfArgs();
            for(int l = 0; l < k; l++)
                oraclepreparedstatement.setItem(j++, dbdataset.getType(l), dbdataset.getBytesItem(l, 0));

        }
        return k + 1;
    }

    private void setIsNull(int i)
    {
        m_wasNull = i;
    }

    private void setIsNull(boolean flag)
    {
        if(flag)
            m_wasNull = 1;
        else
            m_wasNull = 2;
    }

    static final int s_concurrencyType = 1008;
    static final int s_beginColumnIndex = 1;
    OracleConnection m_conn;
    OracleResultSet m_rset;
    boolean m_isCachedRset;
    ScrollRsetStatement m_scrollStmt;
    ResultSetMetaData m_metadata;
    private int m_type;
    private int m_columnCount;
    private OraclePreparedStatement m_deleteStmt;
    private OraclePreparedStatement m_insertStmt;
    private String m_updateSql1;
    private String m_updateSql2;
    private OraclePreparedStatement m_updateStmt;
    private int m_idxColsChanged[];
    private Object m_rowBuffer[];
    private boolean m_nullIndicator[];
    private int m_typeInfo[][];
    private boolean m_isInserting;
    private boolean m_isUpdating;
    private int m_wasNull;
    private static final int VALUE_NULL = 1;
    private static final int VALUE_NOT_NULL = 2;
    private static final int VALUE_UNKNOWN = 3;
    private static final int VALUE_IN_RSET = 4;
    private static final int ASCII_STREAM = 1;
    private static final int BINARY_STREAM = 2;
    private static final int UNICODE_STREAM = 3;
    private static int _MIN_STREAM_SIZE = 4000;

}
