// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package oracle.net.resolver;

import java.io.IOException;
import java.util.*;
import oracle.net.TNSAddress.*;
import oracle.net.jndi.JndiAttrs;
import oracle.net.nl.*;
import oracle.net.ns.NetException;
import oracle.net.nt.ConnOption;
import oracle.net.nt.ConnStrategy;

// Referenced classes of package oracle.net.resolver:
//            NavSchemaObjectFactory, NavServiceAlias

public class AddrResolution
{

    public AddrResolution(String s, Properties properties)
        throws NetException
    {
        newSyntax = true;
        jndi = false;
        connection_revised = false;
        String as[] = new String[1];
        up = properties;
        TNSAddress = s;
        if(up.containsKey("java.naming.provider.url") || s.startsWith("ldap:"))
        {
            if(s.startsWith("ldap:"))
            {
                up.put("java.naming.provider.url", s.substring(s.indexOf("ldap:"), s.lastIndexOf('/')));
                TNSAddress = s.substring(s.lastIndexOf('/') + 1, s.length());
            }
            ja = new JndiAttrs(up);
            jndi = true;
            as[0] = "orclnetdescstring";
            Vector vector = ja.getAttrs(TNSAddress, as);
            TNSAddress = (String)vector.firstElement();
            connection_revised = true;
        }
        if(up.getProperty("oracle.net.oldSyntax") == "YES")
            newSyntax = false;
    }

    public JndiAttrs getJndi()
    {
        return ja;
    }

    public String getTNSAddress()
    {
        return TNSAddress.toUpperCase();
    }

    public Properties getUp()
    {
        return up;
    }

    private StringBuffer insertCID(String s)
        throws NetException
    {
        NVFactory nvfactory = new NVFactory();
        NVNavigator nvnavigator = new NVNavigator();
        StringBuffer stringbuffer = new StringBuffer(2048);
        NVPair nvpair = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "description");
        NVPair nvpair1 = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "address_list");
        NVPair nvpair2 = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "address");
        NVPair nvpair3 = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "connect_data");
        NVPair nvpair4 = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "source_route");
        NVPair nvpair5 = null;
        Object obj = null;
        NVPair nvpair7 = null;
        if(nvpair3 != null)
        {
            nvpair5 = nvnavigator.findNVPair(nvpair3, "SID");
            NVPair nvpair6 = nvnavigator.findNVPair(nvpair3, "CID");
            nvpair7 = nvnavigator.findNVPair(nvpair3, "SERVICE_NAME");
        } else
        {
            throw new NetException(105);
        }
        if(nvpair5 == null && nvpair7 == null)
            throw new NetException(106);
        stringbuffer.append("(DESCRIPTION=");
        if(nvpair1 != null && nvpair1.getListSize() > 0)
        {
            for(int i = 0; i < nvpair1.getListSize(); i++)
            {
                NVPair nvpair8 = nvpair1.getListElement(i);
                stringbuffer.append(nvpair8.toString());
            }

        } else
        if(nvpair2 != null)
            stringbuffer.append(nvpair2.toString());
        else
            throw new NetException(107);
        if(nvpair7 != null)
            stringbuffer.append("(CONNECT_DATA=" + nvpair7.toString() + "(CID=(PROGRAM=)(HOST=__jdbc__)(USER=)))");
        else
            stringbuffer.append("(CONNECT_DATA=" + nvpair5.toString() + "(CID=(PROGRAM=)(HOST=__jdbc__)(USER=)))");
        if(nvpair4 != null)
            stringbuffer.append(nvpair4.toString());
        stringbuffer.append(")");
        return stringbuffer;
    }

    private void resolveAddr(String s)
        throws NetException
    {
        if(s.startsWith("alias="))
        {
            String s1 = s;
            s = s1.substring(s1.indexOf("alias=") + 6, s1.length());
        }
        ConnOption connoption = new ConnOption();
        NVFactory nvfactory = new NVFactory();
        NVNavigator nvnavigator = new NVNavigator();
        NVPair nvpair = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "CID");
        NVPair nvpair1 = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "address");
        NVPair nvpair2 = nvnavigator.findNVPair(nvpair1, "protocol");
        if(nvpair2 == null)
            throw new NetException(100);
        connoption.protocol = nvpair2.getAtom();
        if(!connoption.protocol.equals("TCP") && !connoption.protocol.equals("tcp") && !connoption.protocol.equals("SSL") && !connoption.protocol.equals("ssl") && !connoption.protocol.equals("ANO") && !connoption.protocol.equals("ano"))
            throw new NetException(102);
        nvpair2 = nvnavigator.findNVPair(nvpair1, "Host");
        if(nvpair2 == null)
            throw new NetException(103);
        connoption.host = nvpair2.getAtom();
        nvpair2 = nvnavigator.findNVPair(nvpair1, "Port");
        if(nvpair2 == null)
            throw new NetException(104);
        connoption.port = Integer.parseInt(nvpair2.getAtom());
        nvpair2 = nvnavigator.findNVPair(nvpair1, "sduSize");
        if(nvpair2 != null)
            connoption.sdu = Integer.parseInt(nvpair2.getAtom());
        nvpair2 = nvnavigator.findNVPair(nvpair1, "tduSize");
        if(nvpair2 != null)
            connoption.tdu = Integer.parseInt(nvpair2.getAtom());
        NVPair nvpair3 = nvnavigator.findNVPairRecurse(nvfactory.createNVPair(s), "connect_data");
        StringBuffer stringbuffer = new StringBuffer(s);
        connoption.conn_data = nvpair3 == null ? stringbuffer : insertCID(s);
        connoption.addr = "(ADDRESS=(PROTOCOL=tcp)(HOST=" + connoption.host + ")(PORT=" + connoption.port + "))";
        cs.addOption(connoption);
    }

    private void resolveAddrTree(String s)
        throws NetException
    {
        NavSchemaObjectFactory navschemaobjectfactory = new NavSchemaObjectFactory();
        NavServiceAlias navservicealias = (NavServiceAlias)navschemaobjectfactory.create(4);
        try
        {
            String s1 = s.startsWith("alias=") ? s : "alias=" + s;
            navservicealias.initFromString(s1);
        }
        catch(NLException _ex)
        {
            throw new NetException(501);
        }
        catch(SOException soexception)
        {
            throw new NetException(502, soexception.getMessage());
        }
        navservicealias.navigate(cs, null);
    }

    public ConnOption resolveAndExecute(String s)
        throws NetException, IOException
    {
        cs = new ConnStrategy();
        if(s.indexOf("//") != -1)
            resolveUrl(s);
        else
        if(s.indexOf(':') != -1 && s.indexOf(')') == -1)
            resolveSimple(s);
        else
        if(newSyntax)
            resolveAddrTree(s);
        else
            resolveAddr(s);
        if(!cs.optAvailable())
            return cs.execute();
        else
            return cs.getOption();
    }

    private void resolveSimple(String s)
        throws NetException
    {
        ConnOption connoption = new ConnOption();
        int i = 0;
        int j = 0;
        int k = 0;
        if((i = s.indexOf(':')) == -1 || (j = s.indexOf(':', i + 1)) == -1)
            throw new NetException(115);
        if((k = s.indexOf(':', j + 1)) != -1)
            throw new NetException(115);
        try
        {
            connoption.host = s.substring(0, i);
            connoption.port = Integer.parseInt(s.substring(i + 1, j));
            connoption.addr = "(ADDRESS=(PROTOCOL=tcp)(HOST=" + connoption.host + ")(PORT=" + connoption.port + "))";
            connoption.sid = s.substring(j + 1, s.length());
            String s1 = "(DESCRIPTION=(CONNECT_DATA=(SID=" + connoption.sid + ")(CID=(PROGRAM=)(HOST=__jdbc__)(USER=)))" + "(ADDRESS=" + "(PROTOCOL=tcp)(HOST=" + connoption.host + ")(PORT=" + connoption.port + ")))";
            connoption.protocol = "TCP";
            connoption.conn_data = new StringBuffer(s1);
            cs.addOption(connoption);
        }
        catch(NumberFormatException _ex)
        {
            throw new NetException(116);
        }
    }

    private void resolveUrl(String s)
        throws NetException
    {
        ConnOption connoption = new ConnOption();
        int i = 0;
        int j = 0;
        int k = 0;
        if((i = s.indexOf("//")) == -1 || (j = s.indexOf(':', i + 2)) == -1 || (k = s.indexOf('/', j + 1)) == -1 || k + 1 == s.length())
            throw new NetException(117);
        try
        {
            connoption.host = s.substring(i + 2, j);
            connoption.port = Integer.parseInt(s.substring(j + 1, k));
            connoption.addr = "(ADDRESS=(PROTOCOL=tcp)(HOST=" + connoption.host + ")(PORT=" + connoption.port + "))";
            connoption.service_name = s.substring(k + 1, s.length());
            String s1 = "(DESCRIPTION=(CONNECT_DATA=(SERVICE_NAME=" + connoption.service_name + ")(CID=(PROGRAM=)(HOST=__jdbc__)(USER=)))" + "(ADDRESS=" + "(PROTOCOL=tcp)(HOST=" + connoption.host + ")(PORT=" + connoption.port + ")))";
            connoption.protocol = "TCP";
            connoption.conn_data = new StringBuffer(s1);
            cs.addOption(connoption);
        }
        catch(NumberFormatException _ex)
        {
            throw new NetException(116);
        }
    }

    private ConnStrategy cs;
    private Properties up;
    private static final String default_proxy_rules = "__jdbc__";
    private static final String service_alias_name = "ora-net-service-alias";
    private static final String service_attr_name = "orclnetdescstring";
    private static final int length_of_alias_prefix = 6;
    private JndiAttrs ja;
    private boolean newSyntax;
    public boolean jndi;
    public boolean connection_revised;
    private String TNSAddress;
}
