// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   CHAR.java

package oracle.sql;

import java.io.*;
import java.math.BigDecimal;
import java.sql.*;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.util.RepConversion;

// Referenced classes of package oracle.sql:
//            Datum, CharacterSet

public class CHAR extends Datum
{

    protected CHAR()
    {
    }

    public CHAR(byte abyte0[], CharacterSet characterset)
    {
        setValue(abyte0, characterset);
    }

    public CHAR(byte abyte0[], int i, int j, CharacterSet characterset)
    {
        byte abyte1[] = new byte[j];
        System.arraycopy(abyte0, i, abyte1, 0, j);
        setValue(abyte1, characterset);
    }

    public CHAR(String s, CharacterSet characterset)
        throws SQLException
    {
        if(characterset == null)
            characterset = DEFAULT_CHARSET;
        setValue(characterset.convert(s), characterset);
    }

    public CHAR(Object obj, CharacterSet characterset)
        throws SQLException
    {
        this(obj.toString(), characterset);
    }

    public CharacterSet getCharacterSet()
    {
        if(charSet == null)
        {
            if(oracleId == 0)
                oracleId = -1;
            charSet = CharacterSet.make(oracleId);
        }
        return charSet;
    }

    public String getString()
        throws SQLException
    {
        String s = getCharacterSet().toString(shareBytes(), 0, (int)getLength());
        return s;
    }

    public String getStringWithReplacement()
    {
        byte abyte0[] = shareBytes();
        String s = getCharacterSet().toStringWithReplacement(abyte0, 0, abyte0.length);
        return s;
    }

    public String toString()
    {
        String s;
        try
        {
            s = getString();
        }
        catch(SQLException sqlexception)
        {
            StringBuffer stringbuffer = new StringBuffer();
            stringbuffer.append("0x");
            byte abyte0[] = shareBytes();
            for(int i = 0; i < abyte0.length; i++)
            {
                stringbuffer.append((char)RepConversion.nibbleToHex((byte)(abyte0[i] >> 4 & 0xf)));
                stringbuffer.append((char)RepConversion.nibbleToHex((byte)(abyte0[i] & 0xf)));
            }

            s = stringbuffer.toString();
        }
        return s;
    }

    public boolean equals(Object obj)
    {
        return (obj instanceof CHAR) && getCharacterSet().equals(((CHAR)obj).getCharacterSet()) && super.equals(obj);
    }

    void setValue(byte abyte0[], CharacterSet characterset)
    {
        charSet = characterset != null ? characterset : DEFAULT_CHARSET;
        oracleId = charSet.getOracleId();
        setShareBytes(abyte0 != null ? abyte0 : empty);
    }

    public Object toJdbc()
        throws SQLException
    {
        return stringValue();
    }

    public boolean isConvertibleTo(Class class1)
    {
        String s = class1.getName();
        return s.compareTo("java.lang.String") == 0 || s.compareTo("java.lang.Long") == 0 || s.compareTo("java.math.BigDecimal") == 0 || s.compareTo("java.io.InputStream") == 0 || s.compareTo("java.sql.Date") == 0 || s.compareTo("java.sql.Time") == 0 || s.compareTo("java.sql.Timestamp") == 0 || s.compareTo("java.io.Reader") == 0;
    }

    public String stringValue()
    {
        return toString();
    }

    public boolean booleanValue()
        throws SQLException
    {
        boolean flag = false;
        String s = stringValue();
        if(s == null)
            flag = false;
        else
        if(s.length() == 1 && s.charAt(0) == '0')
            flag = false;
        else
            flag = true;
        return flag;
    }

    public int intValue()
        throws SQLException
    {
        long l = longValue();
        if(l > 0x7fffffffL || l < 0xffffffff80000000L)
            DBError.throwSqlException(26);
        int i = (int)l;
        return i;
    }

    public long longValue()
        throws SQLException
    {
        long l = 0L;
        try
        {
            l = Long.valueOf(stringValue()).longValue();
        }
        catch(NumberFormatException numberformatexception)
        {
            DBError.throwSqlException(59);
        }
        return l;
    }

    public float floatValue()
        throws SQLException
    {
        float f = 0.0F;
        try
        {
            f = Float.valueOf(stringValue()).floatValue();
        }
        catch(NumberFormatException numberformatexception)
        {
            DBError.throwSqlException(59);
        }
        return f;
    }

    public double doubleValue()
        throws SQLException
    {
        double d = 0.0D;
        try
        {
            d = Double.valueOf(stringValue()).doubleValue();
        }
        catch(NumberFormatException numberformatexception)
        {
            DBError.throwSqlException(59);
        }
        return d;
    }

    public byte byteValue()
        throws SQLException
    {
        long l = longValue();
        if(l > 127L || l < -128L)
            DBError.throwSqlException(26);
        byte byte0 = (byte)(int)l;
        return byte0;
    }

    public Date dateValue()
        throws SQLException
    {
        Date date = Date.valueOf(stringValue());
        return date;
    }

    public Time timeValue()
        throws SQLException
    {
        Time time = Time.valueOf(stringValue());
        return time;
    }

    public Timestamp timestampValue()
        throws SQLException
    {
        Timestamp timestamp = Timestamp.valueOf(stringValue());
        return timestamp;
    }

    public BigDecimal bigDecimalValue()
        throws SQLException
    {
        BigDecimal bigdecimal = null;
        try
        {
            bigdecimal = new BigDecimal(stringValue());
        }
        catch(NumberFormatException numberformatexception)
        {
            DBError.check_error(12, "bigDecimalValue");
        }
        return bigdecimal;
    }

    public Reader characterStreamValue()
        throws SQLException
    {
        StringReader stringreader = new StringReader(getString());
        return stringreader;
    }

    public InputStream asciiStreamValue()
        throws SQLException
    {
        return getStream();
    }

    public InputStream binaryStreamValue()
        throws SQLException
    {
        return getStream();
    }

    public Object makeJdbcArray(int i)
    {
        return new String[i];
    }

    public static final CharacterSet DEFAULT_CHARSET = CharacterSet.make(-1);
    private CharacterSet charSet;
    private int oracleId;
    private static byte empty[] = new byte[0];

}
