// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   CLOB.java

package oracle.sql;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.internal.OracleConnection;

// Referenced classes of package oracle.sql:
//            DatumWithConnection, ClobDBAccess

public class CLOB extends DatumWithConnection
    implements Clob
{

    protected CLOB()
    {
    }

    public CLOB(oracle.jdbc.OracleConnection oracleconnection)
        throws SQLException
    {
        this(oracleconnection, null);
    }

    public CLOB(oracle.jdbc.OracleConnection oracleconnection, byte abyte0[])
        throws SQLException
    {
        super(abyte0);
        if(abyte0 != null)
            if((abyte0[5] & 0xc0) == 64)
                csform = 2;
            else
                csform = 1;
        DatumWithConnection.assertNotNull(oracleconnection);
        setPhysicalConnectionOf(oracleconnection);
        m_dbaccess = ((OracleConnection)oracleconnection).createClobDBAccess();
        m_dbChunkSize = -1;
    }

    public CLOB(oracle.jdbc.OracleConnection oracleconnection, byte abyte0[], short word0)
        throws SQLException
    {
        this(oracleconnection, abyte0);
        csform = word0;
    }

    public boolean isNCLOB()
    {
        boolean flag = csform == 2;
        return flag;
    }

    public long length()
        throws SQLException
    {
        return getDBAccess().length(this);
    }

    public String getSubString(long l, int i)
        throws SQLException
    {
        if(i < 0 || l < 1L)
            DBError.check_error(68, "getSubString");
        String s = null;
        if(i == 0)
        {
            s = new String();
        } else
        {
            char ac[] = new char[i];
            int j = getChars(l, i, ac);
            if(j > 0)
                s = new String(ac, 0, j);
            else
                s = new String();
        }
        return s;
    }

    public Reader getCharacterStream()
        throws SQLException
    {
        return getDBAccess().newReader(this, getBufferSize(), 0L);
    }

    public InputStream getAsciiStream()
        throws SQLException
    {
        return getDBAccess().newInputStream(this, getBufferSize(), 0L);
    }

    public long position(String s, long l)
        throws SQLException
    {
        return getDBAccess().position(this, s, l);
    }

    public long position(Clob clob, long l)
        throws SQLException
    {
        return getDBAccess().position(this, (CLOB)clob, l);
    }

    public int getChars(long l, int i, char ac[])
        throws SQLException
    {
        return getDBAccess().getChars(this, l, i, ac);
    }

    public Writer getCharacterOutputStream()
        throws SQLException
    {
        return getDBAccess().newWriter(this, getBufferSize(), 0L);
    }

    public OutputStream getAsciiOutputStream()
        throws SQLException
    {
        return getDBAccess().newOutputStream(this, getBufferSize(), 0L);
    }

    public byte[] getLocator()
    {
        return getBytes();
    }

    public void setLocator(byte abyte0[])
    {
        setBytes(abyte0);
    }

    public int putChars(long l, char ac[])
        throws SQLException
    {
        int i = getDBAccess().putChars(this, l, ac, ac == null ? 0 : ac.length);
        return i;
    }

    public int putChars(long l, char ac[], int i)
        throws SQLException
    {
        return getDBAccess().putChars(this, l, ac, i);
    }

    public int putString(long l, String s)
        throws SQLException
    {
        if(l < 1L)
            DBError.check_error(68, "putString()");
        int i = 0;
        if(s != null && s.length() != 0)
            i = putChars(l, s.toCharArray());
        return i;
    }

    public int getChunkSize()
        throws SQLException
    {
        if(m_dbChunkSize <= 0)
            m_dbChunkSize = getDBAccess().getChunkSize(this);
        return m_dbChunkSize;
    }

    public int getBufferSize()
        throws SQLException
    {
        int i = getChunkSize();
        int j = 0;
        if(i >= 32768 || i <= 0)
            j = 32768;
        else
            j = (32768 / i) * i;
        return j;
    }

    public static CLOB empty_lob()
        throws SQLException
    {
        byte abyte0[] = new byte[86];
        abyte0[1] = 84;
        abyte0[5] = 24;
        CLOB clob = new CLOB();
        clob.setShareBytes(abyte0);
        return clob;
    }

    public boolean isEmptyLob()
        throws SQLException
    {
        return (shareBytes()[5] & 0x10) != 0;
    }

    public OutputStream getAsciiOutputStream(long l)
        throws SQLException
    {
        return getDBAccess().newOutputStream(this, getBufferSize(), l);
    }

    public Writer getCharacterOutputStream(long l)
        throws SQLException
    {
        return getDBAccess().newWriter(this, getBufferSize(), l);
    }

    public InputStream getAsciiStream(long l)
        throws SQLException
    {
        return getDBAccess().newInputStream(this, getBufferSize(), l);
    }

    public Reader getCharacterStream(long l)
        throws SQLException
    {
        return getDBAccess().newReader(this, getBufferSize(), l);
    }

    public void trim(long l)
        throws SQLException
    {
        if(l < 0L)
            DBError.throwSqlException(68);
        getDBAccess().trim(this, l);
    }

    public static CLOB createTemporary(Connection connection, boolean flag, int i)
        throws SQLException
    {
        if(connection == null || i != 1 && i != 2)
            DBError.throwSqlException(68);
        OracleConnection oracleconnection = oracle.jdbc.driver.OracleConnection.physicalConnectionWithin(connection);
        return getDBAccess(oracleconnection).createTemporaryClob(oracleconnection, flag, i);
    }

    public static void freeTemporary(CLOB clob)
        throws SQLException
    {
        if(clob == null)
        {
            return;
        } else
        {
            clob.freeTemporary();
            return;
        }
    }

    public static boolean isTemporary(CLOB clob)
        throws SQLException
    {
        if(clob == null)
            return false;
        else
            return clob.isTemporary();
    }

    public void freeTemporary()
        throws SQLException
    {
        getDBAccess().freeTemporary(this);
    }

    public boolean isTemporary()
        throws SQLException
    {
        return getDBAccess().isTemporary(this);
    }

    public void open(int i)
        throws SQLException
    {
        getDBAccess().open(this, i);
    }

    public void close()
        throws SQLException
    {
        getDBAccess().close(this);
    }

    public boolean isOpen()
        throws SQLException
    {
        return getDBAccess().isOpen(this);
    }

    public int setString(long l, String s)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return -1;
    }

    public int setString(long l, String s, int i, int j)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return -1;
    }

    public OutputStream setAsciiStream(long l)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return null;
    }

    public Writer setCharacterStream(long l)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return null;
    }

    public void truncate(long l)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
    }

    public Object toJdbc()
        throws SQLException
    {
        return this;
    }

    public boolean isConvertibleTo(Class class1)
    {
        String s = class1.getName();
        return s.compareTo("java.io.InputStream") == 0 || s.compareTo("java.io.Reader") == 0;
    }

    public Reader characterStreamValue()
        throws SQLException
    {
        return getCharacterStream();
    }

    public InputStream asciiStreamValue()
        throws SQLException
    {
        return getAsciiStream();
    }

    public InputStream binaryStreamValue()
        throws SQLException
    {
        return getAsciiStream();
    }

    public Object makeJdbcArray(int i)
    {
        return new CLOB[i];
    }

    public ClobDBAccess getDBAccess()
        throws SQLException
    {
        if(m_dbaccess == null)
        {
            if(isEmptyLob())
                DBError.throwSqlException(98);
            m_dbaccess = getInternalConnection().createClobDBAccess();
        }
        return m_dbaccess;
    }

    public static ClobDBAccess getDBAccess(Connection connection)
        throws SQLException
    {
        return oracle.jdbc.driver.OracleConnection.physicalConnectionWithin(connection).createClobDBAccess();
    }

    public Connection getJavaSqlConnection()
        throws SQLException
    {
        return super.getJavaSqlConnection();
    }

    public oracle.jdbc.driver.OracleConnection getConnection()
        throws SQLException
    {
        return super.getConnection();
    }

    public static final int MAX_CHUNK_SIZE = 32768;
    public static final int DURATION_SESSION = 1;
    public static final int DURATION_CALL = 2;
    public static final int MODE_READONLY = 0;
    public static final int MODE_READWRITE = 1;
    ClobDBAccess m_dbaccess;
    private int m_dbChunkSize;
    private short csform;
}
