// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   StructDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.util.Map;
import java.util.Vector;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.StructMetaData;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleType;
import oracle.jdbc.oracore.OracleTypeADT;

// Referenced classes of package oracle.sql:
//            TypeDescriptor, SQLName, STRUCT, OracleJdbc2SQLInput, 
//            OracleSQLOutput, Datum, ArrayDescriptor, OpaqueDescriptor

public class StructDescriptor extends TypeDescriptor
    implements Serializable
{

    public static StructDescriptor createDescriptor(String s, Connection connection)
        throws SQLException
    {
        if(s == null || s.length() == 0 || connection == null)
            DBError.check_error(60, "Invalid arguments");
        SQLName sqlname = new SQLName(s, (OracleConnection)connection);
        String s1 = sqlname.getName();
        StructDescriptor structdescriptor = (StructDescriptor)((OracleConnection)connection).getDescriptor(s1);
        if(structdescriptor == null)
        {
            structdescriptor = new StructDescriptor(sqlname, connection);
            ((OracleConnection)connection).putDescriptor(s1, structdescriptor);
        }
        return structdescriptor;
    }

    public StructDescriptor(String s, Connection connection)
        throws SQLException
    {
        super(s, connection);
        m_isInstanciable = null;
        m_supertype = null;
        m_numLocalAttrs = -1;
        m_subtypes = null;
        m_attrJavaNames = null;
        initPickler();
    }

    public StructDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        super(sqlname, connection);
        m_isInstanciable = null;
        m_supertype = null;
        m_numLocalAttrs = -1;
        m_subtypes = null;
        m_attrJavaNames = null;
        initPickler();
    }

    public StructDescriptor(SQLName sqlname, OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        super(sqlname, oracletypeadt, connection);
        m_isInstanciable = null;
        m_supertype = null;
        m_numLocalAttrs = -1;
        m_subtypes = null;
        m_attrJavaNames = null;
    }

    private void initPickler()
        throws SQLException
    {
        try
        {
            m_pickler = new OracleTypeADT(getName(), m_conn);
            ((OracleTypeADT)m_pickler).init((oracle.jdbc.driver.OracleConnection)m_conn);
            m_pickler.setDescriptor(this);
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                throw (SQLException)exception;
            DBError.throwSqlException(60, "Unable to resolve type \"" + getName() + "\"");
        }
    }

    public StructDescriptor(OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        super(oracletypeadt, connection);
        m_isInstanciable = null;
        m_supertype = null;
        m_numLocalAttrs = -1;
        m_subtypes = null;
        m_attrJavaNames = null;
    }

    public int getTypeCode()
        throws SQLException
    {
        int i = m_pickler.getTypeCode();
        return i;
    }

    public int getTypeVersion()
        throws SQLException
    {
        int i = m_pickler.getTypeVersion();
        return i;
    }

    byte[] toBytes(STRUCT struct, boolean flag)
        throws SQLException
    {
        byte abyte0[] = struct.shareBytes();
        if(abyte0 == null)
        {
            if(struct.m_datumArray != null)
            {
                abyte0 = m_pickler.linearize(struct);
                if(!flag)
                    struct.setShareBytes(null);
            } else
            if(struct.m_objArray != null)
            {
                struct.m_datumArray = toOracleArray(struct.m_objArray);
                abyte0 = m_pickler.linearize(struct);
                if(!flag)
                {
                    struct.m_datumArray = null;
                    struct.setShareBytes(null);
                }
            } else
            {
                DBError.throwSqlException(1);
            }
        } else
        if(struct.m_imgLength != 0L && (struct.m_imgOffset != 0L || struct.m_imgLength != (long)abyte0.length))
        {
            byte abyte1[] = new byte[(int)struct.m_imgLength];
            System.arraycopy(abyte0, (int)struct.m_imgOffset, abyte1, 0, (int)struct.m_imgLength);
            struct.setImage(abyte1, 0L, 0L);
            abyte0 = abyte1;
        }
        return abyte0;
    }

    Datum[] toOracleArray(STRUCT struct, boolean flag)
        throws SQLException
    {
        Datum adatum[] = struct.m_datumArray;
        Datum adatum1[] = null;
        if(adatum == null)
            if(struct.m_objArray != null)
                adatum = toOracleArray(struct.m_objArray);
            else
            if(struct.shareBytes() != null)
            {
                if((struct.shareBytes()[0] & 0x80) <= 0 && ((OracleTypeADT)m_pickler).isEmbeddedADT())
                    m_pickler = OracleTypeADT.shallow_clone((OracleTypeADT)m_pickler);
                m_pickler.unlinearize(struct.shareBytes(), struct.m_imgOffset, struct, 1, null);
                adatum = struct.m_datumArray;
                if(!flag)
                    struct.m_datumArray = null;
            } else
            {
                DBError.throwSqlException(1);
            }
        if(flag)
        {
            struct.m_datumArray = adatum;
            adatum1 = (Datum[])adatum.clone();
        } else
        {
            adatum1 = adatum;
        }
        return adatum1;
    }

    Object[] toArray(STRUCT struct, Map map, boolean flag)
        throws SQLException
    {
        Object aobj[] = null;
        if(struct.m_objArray == null)
        {
            if(struct.m_datumArray != null)
            {
                aobj = new Object[struct.m_datumArray.length];
                for(int i = 0; i < struct.m_datumArray.length; i++)
                    if(struct.m_datumArray[i] != null)
                        if(struct.m_datumArray[i] instanceof STRUCT)
                            aobj[i] = ((STRUCT)struct.m_datumArray[i]).toJdbc(map);
                        else
                            aobj[i] = struct.m_datumArray[i].toJdbc();

            } else
            if(struct.shareBytes() != null)
            {
                if((struct.shareBytes()[0] & 0x80) <= 0 && ((OracleTypeADT)m_pickler).isEmbeddedADT())
                    m_pickler = OracleTypeADT.shallow_clone((OracleTypeADT)m_pickler);
                m_pickler.unlinearize(struct.shareBytes(), struct.m_imgOffset, struct, 2, map);
                aobj = struct.m_objArray;
                struct.m_objArray = null;
            } else
            {
                DBError.throwSqlException(1);
            }
        } else
        {
            aobj = (Object[])struct.m_objArray.clone();
        }
        return aobj;
    }

    public int getLength()
        throws SQLException
    {
        int i = getFieldTypes().length;
        return i;
    }

    public OracleTypeADT getOracleTypeADT()
    {
        OracleTypeADT oracletypeadt = (OracleTypeADT)m_pickler;
        return oracletypeadt;
    }

    private OracleType[] getFieldTypes()
        throws SQLException
    {
        OracleType aoracletype[] = ((OracleTypeADT)m_pickler).getAttrTypes();
        return aoracletype;
    }

    public SQLInput toJdbc2SQLInput(STRUCT struct, Map map)
        throws SQLException
    {
        OracleJdbc2SQLInput oraclejdbc2sqlinput = new OracleJdbc2SQLInput(toOracleArray(struct, false), map, m_conn);
        return oraclejdbc2sqlinput;
    }

    public SQLOutput toJdbc2SQLOutput()
        throws SQLException
    {
        OracleSQLOutput oraclesqloutput = new OracleSQLOutput(this, m_conn);
        return oraclesqloutput;
    }

    public Datum[] toOracleArray(Object aobj[])
        throws SQLException
    {
        Datum adatum[] = null;
        if(aobj != null)
        {
            OracleType aoracletype[] = getFieldTypes();
            int i = aoracletype.length;
            if(aobj.length != i)
                DBError.check_error(49, null);
            adatum = new Datum[i];
            for(int j = 0; j < i; j++)
                adatum[j] = aoracletype[j].toDatum(aobj[j], (oracle.jdbc.driver.OracleConnection)m_conn);

        }
        return adatum;
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        StructMetaData structmetadata = new StructMetaData(this);
        return structmetadata;
    }

    public boolean isFinalType()
        throws SQLException
    {
        boolean flag = getOracleTypeADT().isFinalType();
        return flag;
    }

    public boolean isSubtype()
        throws SQLException
    {
        boolean flag = getOracleTypeADT().isSubType();
        return flag;
    }

    public boolean isInHierarchyOf(String s)
        throws SQLException
    {
        StructDescriptor structdescriptor = this;
        String s1 = structdescriptor.getName();
        boolean flag = false;
        if(s.equals(s1))
            flag = true;
        else
            do
            {
                String s2 = structdescriptor.getSupertypeName();
                if(s2 == null)
                {
                    flag = false;
                    break;
                }
                if(s.equals(s2))
                {
                    flag = true;
                    break;
                }
                structdescriptor = createDescriptor(s2, m_conn);
            } while(true);
        return flag;
    }

    public boolean isInstantiable()
        throws SQLException
    {
        if(m_isInstanciable == null)
            initMetaData1();
        boolean flag = m_isInstanciable.booleanValue();
        return flag;
    }

    public boolean isJavaObject()
        throws SQLException
    {
        boolean flag = getOracleTypeADT().isJavaObject();
        return flag;
    }

    public String getSupertypeName()
        throws SQLException
    {
        String s = null;
        if(isSubtype())
        {
            if(m_supertype == null)
                initMetaData1();
            s = m_supertype;
        }
        return s;
    }

    public int getLocalAttributeCount()
        throws SQLException
    {
        int i;
        if(!isSubtype())
        {
            i = getOracleTypeADT().getAttrTypes().length;
        } else
        {
            if(m_numLocalAttrs == -1)
                initMetaData1();
            i = m_numLocalAttrs;
        }
        return i;
    }

    public String[] getSubtypeNames()
        throws SQLException
    {
        if(m_subtypes == null)
            initMetaData2();
        return m_subtypes;
    }

    public String getJavaClassName()
        throws SQLException
    {
        String s = null;
        if(isJavaObject())
            s = getJavaObjectClassName(m_conn, this);
        return s;
    }

    public String getAttributeJavaName(int i)
        throws SQLException
    {
        String s = null;
        if(isJavaObject())
        {
            if(m_attrJavaNames == null)
                initMetaData3();
            s = m_attrJavaNames[i];
        }
        return s;
    }

    public String[] getAttributeJavaNames()
        throws SQLException
    {
        String as[] = null;
        if(isJavaObject())
        {
            if(m_attrJavaNames == null)
                initMetaData3();
            as = m_attrJavaNames;
        } else
        {
            as = new String[0];
        }
        return as;
    }

    public String getLanguage()
        throws SQLException
    {
        String s = null;
        if(isJavaObject())
            s = "JAVA";
        else
            s = "SQL";
        return s;
    }

    public Class getClass(Map map)
        throws SQLException
    {
        String s = getName();
        Class class1 = (Class)map.get(s);
        String s1 = getSchemaName();
        String s2 = getTypeName();
        if(class1 == null && m_conn.getUserName().equals(s1))
            class1 = (Class)map.get(s2);
        if(SQLName.s_parseAllFormat)
        {
            if(class1 == null && m_conn.getUserName().equals(s1))
                class1 = (Class)map.get("\"" + s2 + "\"");
            if(class1 == null)
                class1 = (Class)map.get("\"" + s1 + "\"" + "." + "\"" + s2 + "\"");
            if(class1 == null)
                class1 = (Class)map.get("\"" + s1 + "\"" + "." + s2);
            if(class1 == null)
                class1 = (Class)map.get(s1 + "." + "\"" + s2 + "\"");
        }
        return class1;
    }

    public static String getJavaObjectClassName(Connection connection, StructDescriptor structdescriptor)
        throws SQLException
    {
        String s = getJavaObjectClassName(connection, structdescriptor.getSchemaName(), structdescriptor.getTypeName());
        return s;
    }

    public static String getJavaObjectClassName(Connection connection, String s, String s1)
        throws SQLException
    {
        PreparedStatement preparedstatement = null;
        ResultSet resultset = null;
        String s2 = null;
        try
        {
            preparedstatement = connection.prepareStatement("select external_name from all_sqlj_types where owner = ? and type_name = ?");
            preparedstatement.setString(1, s);
            preparedstatement.setString(2, s1);
            resultset = preparedstatement.executeQuery();
            if(resultset.next())
                s2 = resultset.getString(1);
            else
                DBError.throwSqlException(100);
        }
        catch(SQLException sqlexception) { }
        finally
        {
            if(resultset != null)
                resultset.close();
            if(preparedstatement != null)
                preparedstatement.close();
        }
        return s2;
    }

    public String descType()
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer();
        return descType(stringbuffer, 0);
    }

    String descType(StringBuffer stringbuffer, int i)
        throws SQLException
    {
        String s = "";
        for(int j = 0; j < i; j++)
            s = s + "  ";

        String s1 = s + "  ";
        stringbuffer.append(s);
        stringbuffer.append(getTypeName());
        stringbuffer.append("\n");
        stringbuffer.append(s);
        stringbuffer.append("Subtype=" + getOracleTypeADT().isSubType());
        stringbuffer.append(" JavaObject=" + getOracleTypeADT().isJavaObject());
        stringbuffer.append(" FinalType=" + getOracleTypeADT().isFinalType());
        stringbuffer.append("\n");
        ResultSetMetaData resultsetmetadata = getMetaData();
        int k = resultsetmetadata.getColumnCount();
        for(int l = 0; l < k; l++)
        {
            int i1 = resultsetmetadata.getColumnType(l + 1);
            if(i1 == 2002 || i1 == 2008)
            {
                StructDescriptor structdescriptor = createDescriptor(resultsetmetadata.getColumnTypeName(l + 1), m_conn);
                structdescriptor.descType(stringbuffer, i + 1);
            } else
            if(i1 == 2003)
            {
                ArrayDescriptor arraydescriptor = ArrayDescriptor.createDescriptor(resultsetmetadata.getColumnTypeName(l + 1), m_conn);
                arraydescriptor.descType(stringbuffer, i + 1);
            } else
            if(i1 == 2007)
            {
                OpaqueDescriptor opaquedescriptor = OpaqueDescriptor.createDescriptor(resultsetmetadata.getColumnTypeName(l + 1), m_conn);
                opaquedescriptor.descType(stringbuffer, i + 1);
            } else
            {
                stringbuffer.append(s1);
                stringbuffer.append(resultsetmetadata.getColumnTypeName(l + 1));
                stringbuffer.append("\n");
            }
        }

        String s2 = stringbuffer.toString();
        return s2;
    }

    public byte[] toBytes(Object aobj[])
        throws SQLException
    {
        Datum adatum[] = toOracleArray(aobj);
        return toBytes(adatum);
    }

    /**
     * @deprecated Method toBytes is deprecated
     */

    public byte[] toBytes(Datum adatum[])
        throws SQLException
    {
        STRUCT struct = new STRUCT(this, (byte[])null, m_conn);
        struct.setDatumArray(adatum);
        return m_pickler.linearize(struct);
    }

    public Datum[] toArray(Object aobj[])
        throws SQLException
    {
        return toOracleArray(aobj);
    }

    public Datum[] toArray(byte abyte0[])
        throws SQLException
    {
        STRUCT struct = new STRUCT(this, abyte0, m_conn);
        return toOracleArray(struct, false);
    }

    private void initMetaData1()
        throws SQLException
    {
        short word0 = m_conn.getVersionNumber();
        if(word0 >= 9000)
            initMetaData1_9_0();
        else
            initMetaData1_pre_9_0();
    }

    private void initMetaData1_9_0()
        throws SQLException
    {
        synchronized(m_conn)
        {
            synchronized(this)
            {
                if(m_numLocalAttrs == -1)
                {
                    PreparedStatement preparedstatement = null;
                    ResultSet resultset = null;
                    int i = -1;
                    try
                    {
                        preparedstatement = m_conn.prepareStatement("select INSTANTIABLE, supertype_owner, supertype_name, LOCAL_ATTRIBUTES from all_types where type_name = ? and owner = ? ");
                        preparedstatement.setString(1, getTypeName());
                        preparedstatement.setString(2, getSchemaName());
                        resultset = preparedstatement.executeQuery();
                        if(resultset.next())
                        {
                            m_isInstanciable = new Boolean(resultset.getString(1).equals("YES"));
                            m_supertype = resultset.getString(2) + "." + resultset.getString(3);
                            i = resultset.getInt(4);
                        } else
                        {
                            DBError.throwSqlException(1, "Inconsistent catalog view");
                        }
                    }
                    finally
                    {
                        if(resultset != null)
                            resultset.close();
                        if(preparedstatement != null)
                            preparedstatement.close();
                    }
                    m_numLocalAttrs = i;
                }
            }
        }
    }

    private synchronized void initMetaData1_pre_9_0()
        throws SQLException
    {
        m_isInstanciable = new Boolean(true);
        m_supertype = "";
        m_numLocalAttrs = 0;
    }

    private void initMetaData2()
        throws SQLException
    {
        short word0 = m_conn.getVersionNumber();
        if(word0 >= 9000)
            initMetaData2_9_0();
        else
            initMetaData2_pre_9_0();
    }

    private void initMetaData2_9_0()
        throws SQLException
    {
        synchronized(m_conn)
        {
            synchronized(this)
            {
                if(m_subtypes == null)
                {
                    PreparedStatement preparedstatement = null;
                    ResultSet resultset = null;
                    String as[] = null;
                    try
                    {
                        preparedstatement = m_conn.prepareStatement("select owner, type_name from all_types where supertype_name = ? and supertype_owner = ?");
                        preparedstatement.setString(1, getTypeName());
                        preparedstatement.setString(2, getSchemaName());
                        resultset = preparedstatement.executeQuery();
                        Vector vector = new Vector();
                        for(; resultset.next(); vector.addElement(resultset.getString(1) + "." + resultset.getString(2)));
                        as = new String[vector.size()];
                        for(int i = 0; i < as.length; i++)
                            as[i] = (String)vector.elementAt(i);

                        vector.removeAllElements();
                        vector = null;
                    }
                    finally
                    {
                        if(resultset != null)
                            resultset.close();
                        if(preparedstatement != null)
                            preparedstatement.close();
                    }
                    m_subtypes = as;
                }
            }
        }
    }

    private void initMetaData2_pre_9_0()
        throws SQLException
    {
        m_subtypes = new String[0];
    }

    private void initMetaData3()
        throws SQLException
    {
        synchronized(m_conn)
        {
            synchronized(this)
            {
                if(m_attrJavaNames == null)
                {
                    String as[] = null;
                    PreparedStatement preparedstatement = null;
                    ResultSet resultset = null;
                    try
                    {
                        preparedstatement = m_conn.prepareStatement("select EXTERNAL_ATTR_NAME from all_sqlj_type_attrs where owner = ? and type_name = ?");
                        preparedstatement.setString(1, getSchemaName());
                        preparedstatement.setString(2, getTypeName());
                        resultset = preparedstatement.executeQuery();
                        as = new String[getOracleTypeADT().getAttrTypes().length];
                        for(int i = 0; resultset.next(); i++)
                            as[i] = resultset.getString(1);

                    }
                    finally
                    {
                        if(resultset != null)
                            resultset.close();
                        if(preparedstatement != null)
                            preparedstatement.close();
                    }
                    m_attrJavaNames = as;
                }
            }
        }
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
    }

    static final boolean DEBUG = false;
    static final long serialVersionUID = 0xe122c1707c9af97L;
    transient Boolean m_isInstanciable;
    transient String m_supertype;
    transient int m_numLocalAttrs;
    transient String m_subtypes[];
    transient String m_attrJavaNames[];
}
