// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleConversionReader.java

package oracle.jdbc.driver;

import java.io.*;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBConversion;
import oracle.jdbc.dbaccess.DBError;

public class OracleConversionReader extends Reader
{

    public OracleConversionReader(DBConversion dbconversion, InputStream inputstream, int i)
        throws SQLException
    {
        if(dbconversion == null || inputstream == null || i != 8 && i != 9)
            DBError.throwSqlException(68);
        db_conversion = dbconversion;
        conversion = i;
        istream = inputstream;
        pos = count = 0;
        numUnconvertedBytes = 0;
        isClosed = false;
        if(i == 8)
        {
            byteBuf = new byte[2048];
            buf = new char[4096];
        } else
        if(i == 9)
        {
            byteBuf = new byte[4096];
            buf = new char[4096];
        }
    }

    public void setFormOfUse(short word0)
    {
        csform = word0;
    }

    public int read(char ac[], int i, int j)
        throws IOException
    {
        ensureOpen();
        if(!needChars())
            return -1;
        int k = i;
        int l = k + Math.min(j, ac.length - i);
        for(k += writeChars(ac, k, l - k); k < l && needChars(); k += writeChars(ac, k, l - k));
        return k - i;
    }

    protected boolean needChars()
        throws IOException
    {
        ensureOpen();
        if(pos >= count)
        {
            if(!endOfStream)
                try
                {
                    int i = istream.read(byteBuf, numUnconvertedBytes, byteBuf.length - numUnconvertedBytes);
                    if(i == -1)
                    {
                        endOfStream = true;
                        istream.close();
                        if(numUnconvertedBytes != 0)
                            DBError.throwSqlException(55);
                    }
                    i += numUnconvertedBytes;
                    if(i > 0)
                    {
                        switch(conversion)
                        {
                        case 8: // '\b'
                            count = RAWBytesToHexChars(byteBuf, i, buf);
                            break;

                        case 9: // '\t'
                            int ai[] = {
                                i
                            };
                            if(csform == 2)
                                count = db_conversion.NCHARBytesToJavaChars(byteBuf, ai, buf);
                            else
                                count = db_conversion.CHARBytesToJavaChars(byteBuf, ai, buf);
                            numUnconvertedBytes = ai[0];
                            for(int j = 0; j < numUnconvertedBytes; j++)
                                byteBuf[j] = byteBuf[(i - numUnconvertedBytes) + j];

                            break;

                        default:
                            DBError.throwSqlException(23);
                            break;
                        }
                        if(count > 0)
                        {
                            pos = 0;
                            return true;
                        }
                    }
                }
                catch(SQLException sqlexception)
                {
                    DBError.SQLToIOException(sqlexception);
                }
            return false;
        } else
        {
            return true;
        }
    }

    protected int writeChars(char ac[], int i, int j)
    {
        int k = Math.min(j, count - pos);
        System.arraycopy(buf, pos, ac, i, k);
        pos += k;
        return k;
    }

    public boolean ready()
        throws IOException
    {
        ensureOpen();
        return pos < count;
    }

    public void close()
        throws IOException
    {
        if(!isClosed)
        {
            isClosed = true;
            istream.close();
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(isClosed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    static final int CHUNK_SIZE = 4096;
    DBConversion db_conversion;
    int conversion;
    InputStream istream;
    char buf[];
    byte byteBuf[];
    int pos;
    int count;
    int numUnconvertedBytes;
    boolean isClosed;
    boolean endOfStream;
    private short csform;
}
