// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleOCIConnectionPool.java

package oracle.jdbc.pool;

import java.sql.*;
import java.util.*;
import javax.naming.*;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.oci.OracleOCIConnection;
import oracle.jdbc.oci8.OCIDBAccess;

// Referenced classes of package oracle.jdbc.pool:
//            OracleDataSource

public class OracleOCIConnectionPool extends OracleDataSource
{

    public OracleOCIConnectionPool(String s, String s1, String s2, Properties properties)
        throws SQLException
    {
        m_conn_min_limit = 0;
        m_conn_max_limit = 0;
        m_conn_increment = 0;
        m_conn_active_size = 0;
        m_conn_pool_size = 0;
        m_conn_timeout = 0;
        m_conn_nowait = "false";
        m_is_transactions_distributed = 0;
        m_lconnections = null;
        m_poolCreated = false;
        m_stmtCacheSize = 0;
        m_stmtClearMetaData = false;
        m_lconnections = new Hashtable(10);
        setDriverType("oci8");
        setURL(s2);
        setUser(s);
        setPassword(s1);
        createConnectionPool(properties);
    }

    public OracleOCIConnectionPool(String s, String s1, String s2)
        throws SQLException
    {
        m_conn_min_limit = 0;
        m_conn_max_limit = 0;
        m_conn_increment = 0;
        m_conn_active_size = 0;
        m_conn_pool_size = 0;
        m_conn_timeout = 0;
        m_conn_nowait = "false";
        m_is_transactions_distributed = 0;
        m_lconnections = null;
        m_poolCreated = false;
        m_stmtCacheSize = 0;
        m_stmtClearMetaData = false;
        m_lconnections = new Hashtable(10);
        setDriverType("oci8");
        setURL(s2);
        setUser(s);
        setPassword(s1);
        createConnectionPool(null);
    }

    public OracleOCIConnectionPool()
        throws SQLException
    {
        m_conn_min_limit = 0;
        m_conn_max_limit = 0;
        m_conn_increment = 0;
        m_conn_active_size = 0;
        m_conn_pool_size = 0;
        m_conn_timeout = 0;
        m_conn_nowait = "false";
        m_is_transactions_distributed = 0;
        m_lconnections = null;
        m_poolCreated = false;
        m_stmtCacheSize = 0;
        m_stmtClearMetaData = false;
        m_lconnections = new Hashtable(10);
        setDriverType("oci8");
    }

    public synchronized Connection getConnection()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Connection connection = getConnection(m_user, m_password);
        return connection;
    }

    public synchronized Connection getConnection(String s, String s1)
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = new Properties();
        properties.put("is_connection_pooling", "true");
        properties.put("user", s);
        properties.put("password", s1);
        properties.put("connection_pool", "connpool_connection");
        properties.put("connpool_object", (OCIDBAccess)m_connection_pool.db_access);
        OracleOCIConnection oracleociconnection = (OracleOCIConnection)DriverManager.getConnection(m_url, properties);
        oracleociconnection.setStmtCacheSize(m_stmtCacheSize, m_stmtClearMetaData);
        m_lconnections.put(oracleociconnection, oracleociconnection);
        oracleociconnection.setConnectionPool(this);
        return oracleociconnection;
    }

    public synchronized Reference getReference()
        throws NamingException
    {
        Reference reference = new Reference(getClass().getName(), "oracle.jdbc.pool.OracleDataSourceFactory", null);
        super.addRefProperties(reference);
        reference.add(new StringRefAddr(CONNPOOL_MIN_LIMIT, String.valueOf(m_conn_min_limit)));
        reference.add(new StringRefAddr(CONNPOOL_MAX_LIMIT, String.valueOf(m_conn_max_limit)));
        reference.add(new StringRefAddr(CONNPOOL_INCREMENT, String.valueOf(m_conn_increment)));
        reference.add(new StringRefAddr(CONNPOOL_ACTIVE_SIZE, String.valueOf(m_conn_active_size)));
        reference.add(new StringRefAddr(CONNPOOL_POOL_SIZE, String.valueOf(m_conn_pool_size)));
        reference.add(new StringRefAddr(CONNPOOL_TIMEOUT, String.valueOf(m_conn_timeout)));
        reference.add(new StringRefAddr(CONNPOOL_NOWAIT, m_conn_nowait));
        reference.add(new StringRefAddr(CONNPOOL_IS_POOLCREATED, String.valueOf(isPoolCreated())));
        reference.add(new StringRefAddr("transactions_distributed", String.valueOf(isDistributedTransEnabled())));
        return reference;
    }

    public synchronized OracleConnection getProxyConnection(String s, Properties properties)
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        if(s == "proxytype_user_name")
            properties.put("user", properties.getProperty("proxy_user_name"));
        else
        if(s == "proxytype_distinguished_name")
            properties.put("user", properties.getProperty("proxy_distinguished_name"));
        else
        if(s == "proxytype_certificate")
            properties.put("user", String.valueOf(properties.getProperty("proxy_user_name")));
        else
            DBError.throwSqlException(107, "null properties");
        properties.put("is_connection_pooling", "true");
        properties.put("proxytype", s);
        String as[];
        if((as = (String[])properties.get("proxy_roles")) != null)
            properties.put("proxy_num_roles", new Integer(as.length));
        else
            properties.put("proxy_num_roles", new Integer(0));
        properties.put("connection_pool", "connpool_proxy_connection");
        properties.put("connpool_object", (OCIDBAccess)m_connection_pool.db_access);
        OracleOCIConnection oracleociconnection = (OracleOCIConnection)DriverManager.getConnection(m_url, properties);
        oracleociconnection.setStmtCacheSize(m_stmtCacheSize, m_stmtClearMetaData);
        m_lconnections.put(oracleociconnection, oracleociconnection);
        oracleociconnection.setConnectionPool(this);
        return oracleociconnection;
    }

    public synchronized OracleConnection getAliasedConnection(byte abyte0[])
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = new Properties();
        properties.put("is_connection_pooling", "true");
        properties.put("connection_id", abyte0);
        properties.put("connection_pool", "connpool_alias_connection");
        properties.put("connpool_object", (OCIDBAccess)m_connection_pool.db_access);
        OracleOCIConnection oracleociconnection = (OracleOCIConnection)DriverManager.getConnection(m_url, properties);
        oracleociconnection.setStmtCacheSize(m_stmtCacheSize, m_stmtClearMetaData);
        m_lconnections.put(oracleociconnection, oracleociconnection);
        oracleociconnection.setConnectionPool(this);
        return oracleociconnection;
    }

    public synchronized void close()
        throws SQLException
    {
        if(!isPoolCreated())
            return;
        for(Enumeration enumeration = m_lconnections.elements(); enumeration.hasMoreElements();)
        {
            OracleOCIConnection oracleociconnection = (OracleOCIConnection)enumeration.nextElement();
            if(oracleociconnection != null && oracleociconnection != m_connection_pool)
                oracleociconnection.close();
        }

        m_connection_pool.close();
    }

    public synchronized void setPoolConfig(Properties properties)
        throws SQLException
    {
        Properties properties1 = new Properties();
        if(properties == null)
            DBError.throwSqlException(106, "null properties");
        if(!isPoolCreated())
        {
            createConnectionPool(properties);
        } else
        {
            checkPoolConfig(properties, properties1);
            ((OCIDBAccess)m_connection_pool.db_access).setConnectionPoolInfo(properties1, m_connection_pool);
        }
        storePoolProperties();
    }

    private void checkPoolConfig(Properties properties, Properties properties1)
        throws SQLException
    {
        String s = (String)properties.get("transactions_distributed");
        String s1 = (String)properties.get(CONNPOOL_NOWAIT);
        if(s != null && !s.equalsIgnoreCase("true") || s1 != null && !s1.equalsIgnoreCase("true") || properties.get(CONNPOOL_MIN_LIMIT) == null || properties.get(CONNPOOL_MAX_LIMIT) == null || properties.get(CONNPOOL_INCREMENT) == null || Integer.decode((String)properties.get(CONNPOOL_MIN_LIMIT)).intValue() < 0 || Integer.decode((String)properties.get(CONNPOOL_MAX_LIMIT)).intValue() < 0 || Integer.decode((String)properties.get(CONNPOOL_INCREMENT)).intValue() < 0)
            DBError.throwSqlException(106, "");
        for(Enumeration enumeration = properties.propertyNames(); enumeration.hasMoreElements();)
        {
            String s2 = (String)enumeration.nextElement();
            String s3 = properties.getProperty(s2);
            if(s2 == "transactions_distributed" || s2 == CONNPOOL_NOWAIT)
                properties1.put(s2, "true");
            else
                properties1.put(s2, s3);
        }

    }

    private synchronized void storePoolProperties()
        throws SQLException
    {
        Properties properties = getPoolConfig();
        m_conn_min_limit = Integer.decode(properties.getProperty(CONNPOOL_MIN_LIMIT)).intValue();
        m_conn_max_limit = Integer.decode(properties.getProperty(CONNPOOL_MAX_LIMIT)).intValue();
        m_conn_increment = Integer.decode(properties.getProperty(CONNPOOL_INCREMENT)).intValue();
        m_conn_active_size = Integer.decode(properties.getProperty(CONNPOOL_ACTIVE_SIZE)).intValue();
        m_conn_pool_size = Integer.decode(properties.getProperty(CONNPOOL_POOL_SIZE)).intValue();
        m_conn_timeout = Integer.decode(properties.getProperty(CONNPOOL_TIMEOUT)).intValue();
        m_conn_nowait = properties.getProperty(CONNPOOL_NOWAIT);
    }

    public synchronized Properties getPoolConfig()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        properties.put(CONNPOOL_IS_POOLCREATED, String.valueOf(isPoolCreated()));
        return properties;
    }

    public synchronized int getActiveSize()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        String s = properties.getProperty(CONNPOOL_ACTIVE_SIZE);
        int i = Integer.decode(s).intValue();
        return i;
    }

    public synchronized int getPoolSize()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        String s = properties.getProperty(CONNPOOL_POOL_SIZE);
        int i = Integer.decode(s).intValue();
        return i;
    }

    public synchronized int getTimeout()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        String s = properties.getProperty(CONNPOOL_TIMEOUT);
        int i = Integer.decode(s).intValue();
        return i;
    }

    public synchronized String getNoWait()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        return properties.getProperty(CONNPOOL_NOWAIT);
    }

    public synchronized int getMinLimit()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        String s = properties.getProperty(CONNPOOL_MIN_LIMIT);
        int i = Integer.decode(s).intValue();
        return i;
    }

    public synchronized int getMaxLimit()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        String s = properties.getProperty(CONNPOOL_MAX_LIMIT);
        int i = Integer.decode(s).intValue();
        return i;
    }

    public synchronized int getConnectionIncrement()
        throws SQLException
    {
        if(!isPoolCreated())
            createConnectionPool(null);
        Properties properties = ((OCIDBAccess)m_connection_pool.db_access).getConnectionPoolInfo();
        String s = properties.getProperty(CONNPOOL_INCREMENT);
        int i = Integer.decode(s).intValue();
        return i;
    }

    public synchronized boolean isDistributedTransEnabled()
    {
        return m_is_transactions_distributed == 1;
    }

    private void createConnectionPool(Properties properties)
        throws SQLException
    {
        if(isPoolCreated())
            return;
        if(m_user == null || m_password == null)
        {
            DBError.throwSqlException(106, " ");
        } else
        {
            Properties properties1 = new Properties();
            if(properties != null)
                checkPoolConfig(properties, properties1);
            properties1.put("is_connection_pooling", "true");
            properties1.put("user", m_user);
            properties1.put("password", m_password);
            properties1.put("connection_pool", "connection_pool");
            if(getURL() == null)
                makeURL();
            m_connection_pool = (OracleOCIConnection)DriverManager.getConnection(m_url, properties1);
            m_poolCreated = true;
            m_connection_pool.setConnectionPool(this);
            m_lconnections.put(m_connection_pool, m_connection_pool);
            storePoolProperties();
            if(properties != null && properties.getProperty("transactions_distributed") != null)
                m_is_transactions_distributed = 1;
        }
    }

    public synchronized boolean isPoolCreated()
    {
        return m_poolCreated;
    }

    public synchronized void connectionClosed(OracleOCIConnection oracleociconnection)
        throws SQLException
    {
        if(m_lconnections.remove(oracleociconnection) == null)
            DBError.throwSqlException(1, "internal OracleOCIConnectionPool error");
    }

    public synchronized void setStmtCacheSize(int i)
        throws SQLException
    {
        setStmtCacheSize(i, false);
    }

    public synchronized void setStmtCacheSize(int i, boolean flag)
        throws SQLException
    {
        if(i < 0)
            DBError.throwSqlException(68);
        m_stmtCacheSize = i;
        m_stmtClearMetaData = flag;
    }

    public synchronized int getStmtCacheSize()
    {
        return m_stmtCacheSize;
    }

    public synchronized boolean isStmtCacheEnabled()
    {
        return m_stmtCacheSize > 0;
    }

    public OracleOCIConnection m_connection_pool;
    public static final String IS_CONNECTION_POOLING = "is_connection_pooling";
    private int m_conn_min_limit;
    private int m_conn_max_limit;
    private int m_conn_increment;
    private int m_conn_active_size;
    private int m_conn_pool_size;
    private int m_conn_timeout;
    private String m_conn_nowait;
    private int m_is_transactions_distributed;
    public static final String CONNPOOL_OBJECT = "connpool_object";
    public static final String CONNPOOL_LOGON_MODE = "connection_pool";
    public static final String CONNECTION_POOL = "connection_pool";
    public static final String CONNPOOL_CONNECTION = "connpool_connection";
    public static final String CONNPOOL_PROXY_CONNECTION = "connpool_proxy_connection";
    public static final String CONNPOOL_ALIASED_CONNECTION = "connpool_alias_connection";
    public static final String PROXY_USER_NAME = "proxy_user_name";
    public static final String PROXY_DISTINGUISHED_NAME = "proxy_distinguished_name";
    public static final String PROXY_CERTIFICATE = "proxy_certificate";
    public static final String PROXY_ROLES = "proxy_roles";
    public static final String PROXY_NUM_ROLES = "proxy_num_roles";
    public static final String PROXY_PASSWORD = "proxy_password";
    public static final String PROXYTYPE = "proxytype";
    public static final String PROXYTYPE_USER_NAME = "proxytype_user_name";
    public static final String PROXYTYPE_DISTINGUISHED_NAME = "proxytype_distinguished_name";
    public static final String PROXYTYPE_CERTIFICATE = "proxytype_certificate";
    public static final String CONNECTION_ID = "connection_id";
    public static String CONNPOOL_MIN_LIMIT = "connpool_min_limit";
    public static String CONNPOOL_MAX_LIMIT = "connpool_max_limit";
    public static String CONNPOOL_INCREMENT = "connpool_increment";
    public static String CONNPOOL_ACTIVE_SIZE = "connpool_active_size";
    public static String CONNPOOL_POOL_SIZE = "connpool_pool_size";
    public static String CONNPOOL_TIMEOUT = "connpool_timeout";
    public static String CONNPOOL_NOWAIT = "connpool_nowait";
    public static String CONNPOOL_IS_POOLCREATED = "connpool_is_poolcreated";
    public static final String TRANSACTIONS_DISTRIBUTED = "transactions_distributed";
    private Hashtable m_lconnections;
    private boolean m_poolCreated;
    protected int m_stmtCacheSize;
    protected boolean m_stmtClearMetaData;

}
