// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleXAResource.java

package oracle.jdbc.xa;

import java.sql.*;
import javax.transaction.xa.*;
import oracle.jdbc.driver.OracleConnection;

// Referenced classes of package oracle.jdbc.xa:
//            OracleXid, OracleXAException

public abstract class OracleXAResource
    implements XAResource
{

    public OracleXAResource()
    {
        m_conn = null;
        m_timeout = 60;
        m_dblink = null;
        l_conn = null;
        m_connSavedTxnMode = 0;
        m_rcvr_sql_cnt = "SELECT count (*) FROM SYS.DBA_PENDING_TRANSACTIONS";
        m_rcvr_sql_rows = "SELECT formatid, globalid, branchid FROM SYS.DBA_PENDING_TRANSACTIONS";
        m_stackedXid = null;
    }

    public OracleXAResource(Connection connection)
        throws XAException
    {
        m_conn = null;
        m_timeout = 60;
        m_dblink = null;
        l_conn = null;
        m_connSavedTxnMode = 0;
        m_rcvr_sql_cnt = "SELECT count (*) FROM SYS.DBA_PENDING_TRANSACTIONS";
        m_rcvr_sql_rows = "SELECT formatid, globalid, branchid FROM SYS.DBA_PENDING_TRANSACTIONS";
        m_stackedXid = null;
        m_conn = connection;
        if(m_conn == null)
            throw new XAException(-7);
        else
            return;
    }

    public synchronized void setConnection(Connection connection)
        throws XAException
    {
        m_conn = connection;
        if(m_conn == null)
            throw new XAException(-7);
        else
            return;
    }

    protected void push(Xid xid)
    {
        m_stackedXid = xid;
        enterGlobalTxnMode();
    }

    protected void pop()
    {
        m_stackedXid = null;
        enterNoTxnMode();
    }

    protected Xid suspendStacked(Xid xid)
        throws XAException
    {
        Xid xid1 = null;
        disallowLocalTxnMode(-3);
        saveTxnMode();
        if(m_stackedXid != null && m_stackedXid != xid)
        {
            xid1 = m_stackedXid;
            end(xid1, 0x2000000);
        }
        return xid1;
    }

    protected Xid suspendStacked(Xid xid, int i)
        throws XAException
    {
        Xid xid1 = null;
        allowGlobalTxnModeOnly(-3);
        saveTxnMode();
        if(i == 0x4000000 && m_stackedXid != null && xid != m_stackedXid)
        {
            xid1 = m_stackedXid;
            end(xid1, 0x2000000);
            start(xid, 0x8000000);
        }
        return xid1;
    }

    protected void resumeStacked(Xid xid)
        throws XAException
    {
        restoreTxnMode();
        if(xid != null)
            start(xid, 0x8000000);
    }

    public abstract void start(Xid xid, int i)
        throws XAException;

    public abstract void end(Xid xid, int i)
        throws XAException;

    public abstract void commit(Xid xid, boolean flag)
        throws XAException;

    public abstract int prepare(Xid xid)
        throws XAException;

    public abstract void forget(Xid xid)
        throws XAException;

    public abstract void rollback(Xid xid)
        throws XAException;

    public Xid[] recover(int i)
        throws XAException
    {
        boolean flag = false;
        Xid axid[] = null;
        if(i != 0 && (i & 0x1000000) != 0x1000000 && (i & 0x800000) != 0x800000)
            throw new XAException(-5);
        try
        {
            saveTxnMode();
            Statement statement = m_conn.createStatement();
            ResultSet resultset = statement.executeQuery(m_rcvr_sql_cnt);
            resultset.next();
            int j = resultset.getInt(1);
            resultset.close();
            axid = new Xid[j];
            if(j == 0)
                return axid;
            boolean flag1 = false;
            Object obj = null;
            Object obj1 = null;
            int l = 0;
            for(ResultSet resultset1 = statement.executeQuery(m_rcvr_sql_rows); resultset1.next();)
            {
                int k = resultset1.getInt(1);
                byte abyte0[] = resultset1.getBytes(2);
                byte abyte1[] = resultset1.getBytes(3);
                axid[l] = new OracleXid(k, abyte0, abyte1);
                l++;
            }

            restoreTxnMode();
        }
        catch(SQLException sqlexception)
        {
            throw new XAException(-3);
        }
        return axid;
    }

    public void resume(Xid xid)
        throws XAException
    {
        start(xid, 0x8000000);
    }

    public void join(Xid xid)
        throws XAException
    {
        start(xid, 0x200000);
    }

    public void suspend(Xid xid)
        throws XAException
    {
        end(xid, 0x2000000);
    }

    public void join(Xid xid, int i)
        throws XAException
    {
        m_timeout = i;
        start(xid, 0x200000);
    }

    public void resume(Xid xid, int i)
        throws XAException
    {
        m_timeout = i;
        start(xid, 0x8000000);
    }

    public Connection getConnection()
    {
        return m_conn;
    }

    public int getTransactionTimeout()
        throws XAException
    {
        return m_timeout;
    }

    public boolean isSameRM(XAResource xaresource)
        throws XAException
    {
        Connection connection = null;
        if(xaresource instanceof OracleXAResource)
            connection = ((OracleXAResource)xaresource).getConnection();
        else
            return false;
        String s = ((OracleConnection)m_conn).getURL();
        String s1 = ((OracleConnection)m_conn).getProtocolType();
        if(connection != null)
        {
            boolean flag = connection.equals(m_conn) || ((OracleConnection)connection).getURL().equals(s) || ((OracleConnection)connection).getProtocolType().equals(s1) && s1.equals("kprb");
            return flag;
        } else
        {
            return false;
        }
    }

    public boolean setTransactionTimeout(int i)
        throws XAException
    {
        if(i < 0)
        {
            throw new XAException(-5);
        } else
        {
            m_timeout = i;
            return true;
        }
    }

    public String getDBLink()
    {
        return m_dblink;
    }

    public void setDBLink(String s)
    {
        m_dblink = s;
    }

    public void setLogicalConnection(Connection connection)
    {
        l_conn = connection;
    }

    protected void disallowLocalTxnMode(int i)
        throws XAException
    {
        if(((OracleConnection)m_conn).m_txn_mode == 1)
            throw new XAException(i);
        else
            return;
    }

    protected void allowGlobalTxnModeOnly(int i)
        throws XAException
    {
        if(((OracleConnection)m_conn).m_txn_mode != 2)
            throw new XAException(i);
        else
            return;
    }

    protected void allowNoTxnModeOnly(int i)
        throws XAException
    {
        if(((OracleConnection)m_conn).m_txn_mode != 0)
            throw new XAException(i);
        else
            return;
    }

    protected void enterNoTxnMode()
    {
        ((OracleConnection)m_conn).m_txn_mode = 0;
    }

    protected void enterGlobalTxnMode()
    {
        ((OracleConnection)m_conn).m_txn_mode = 2;
    }

    protected void saveTxnMode()
    {
        m_connSavedTxnMode = ((OracleConnection)m_conn).m_txn_mode;
    }

    protected void restoreTxnMode()
    {
        if(m_connSavedTxnMode == 0)
            ((OracleConnection)m_conn).m_txn_mode = m_connSavedTxnMode;
    }

    protected void checkError(int i)
        throws OracleXAException
    {
        if((i & 0xffff) != 0)
            throw new OracleXAException(i);
        else
            return;
    }

    public static final int XA_OK = 0;
    public static final short DEFAULT_XA_TIMEOUT = 60;
    public static final int TMNOFLAGS = 0;
    public static final int TMNOMIGRATE = 2;
    public static final int TMENDRSCAN = 0x800000;
    public static final int TMFAIL = 0x20000000;
    public static final int TMJOIN = 0x200000;
    public static final int TMONEPHASE = 0x40000000;
    public static final int TMRESUME = 0x8000000;
    public static final int TMSTARTRSCAN = 0x1000000;
    public static final int TMSUCCESS = 0x4000000;
    public static final int TMSUSPEND = 0x2000000;
    public static final int ORATMREADONLY = 256;
    public static final int ORATMREADWRITE = 512;
    public static final int ORATMSERIALIZABLE = 1024;
    public static final int ORAISOLATIONMASK = 65280;
    protected Connection m_conn;
    protected int m_timeout;
    protected String m_dblink;
    private Connection l_conn;
    protected int m_connSavedTxnMode;
    private String m_rcvr_sql_cnt;
    private String m_rcvr_sql_rows;
    protected Xid m_stackedXid;
}
