// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package oracle.net.ns;

import java.io.*;
import java.util.Properties;
import oracle.net.ano.Ano;
import oracle.net.nt.ConnOption;
import oracle.net.nt.NTAdapter;
import oracle.net.resolver.AddrResolution;

// Referenced classes of package oracle.net.ns:
//            AcceptPacket, ClientProfile, Communication, ConnectPacket, 
//            MarkerPacket, NetException, NetInputStream, NetOutputStream, 
//            Packet, RedirectPacket, RefusePacket, SQLnetDef, 
//            SessionAtts

public class NSProtocol
    implements Communication, SQLnetDef
{

    public NSProtocol()
    {
        sAtts = new SessionAtts(4086, 32767);
        sAtts.connected = false;
    }

    public void connect(String s, Properties properties)
        throws IOException, NetException
    {
        if(sAtts.connected)
            throw new NetException(201);
        if(s == null)
            throw new NetException(208);
        addrRes = new AddrResolution(s, properties);
        if(addrRes.connection_revised)
        {
            s = addrRes.getTNSAddress();
            properties = addrRes.getUp();
        }
        if(addrRes.jndi)
            sAtts.profile = new ClientProfile(properties, addrRes.getJndi());
        else
            sAtts.profile = new ClientProfile(properties);
        establishConnection(s);
        Object obj4 = null;
        try
        {
            obj4 = Class.forName("oracle.net.ano.Ano").newInstance();
            sAtts.anoEnabled = true;
        }
        catch(Exception _ex)
        {
            sAtts.anoEnabled = false;
        }
        if(obj4 != null)
        {
            ((Ano)obj4).init(sAtts);
            sAtts.ano = (Ano)obj4;
            sAtts.anoEnabled = true;
        }
label0:
        do
        {
            ConnectPacket connectpacket = new ConnectPacket(sAtts);
            connectpacket.send();
            packet = new Packet(sAtts);
            packet.receive();
            switch(packet.type)
            {
            case 2: // '\002'
                AcceptPacket acceptpacket = new AcceptPacket(packet);
                break label0;

            case 11: // '\013'
                break;

            case 5: // '\005'
                RedirectPacket redirectpacket = new RedirectPacket(packet);
                sAtts.cOption.nt.disconnect();
                sAtts = establishConnection(redirectpacket.getData());
                break;

            case 4: // '\004'
                RefusePacket refusepacket = new RefusePacket(packet);
                throw new NetException(206, refusepacket.getData());

            case 3: // '\003'
            case 6: // '\006'
            case 7: // '\007'
            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            default:
                sAtts.cOption.nt.disconnect();
                throw new NetException(205);
            }
        } while(true);
        setNetStreams();
        sAtts.connected = true;
        if(sAtts.ano != null)
            sAtts.ano.negotiation();
        packet = null;
        Object obj = null;
        Object obj1 = null;
        Object obj3 = null;
        Object obj2 = null;
    }

    public void disconnect()
        throws IOException, NetException
    {
        if(!sAtts.connected)
        {
            throw new NetException(200);
        } else
        {
            sAtts.nsOutputStream.close();
            sAtts.cOption.nt.disconnect();
            sAtts.connected = false;
            return;
        }
    }

    private SessionAtts establishConnection(String s)
        throws NetException, IOException
    {
        sAtts.cOption = addrRes.resolveAndExecute(s);
        sAtts.ntInputStream = sAtts.cOption.nt.getInputStream();
        sAtts.ntOutputStream = sAtts.cOption.nt.getOutputStream();
        sAtts.setTDU(sAtts.cOption.tdu);
        sAtts.setSDU(sAtts.cOption.sdu);
        sAtts.nsOutputStream = new NetOutputStream(sAtts, 255);
        sAtts.nsInputStream = new NetInputStream(sAtts);
        return sAtts;
    }

    public InputStream getInputStream()
        throws NetException
    {
        if(!sAtts.connected)
            throw new NetException(200);
        else
            return sAtts.nsInputStream;
    }

    public OutputStream getOutputStream()
        throws NetException
    {
        if(!sAtts.connected)
            throw new NetException(200);
        else
            return sAtts.nsOutputStream;
    }

    public void sendBreak()
        throws IOException, NetException
    {
        if(!sAtts.connected)
        {
            throw new NetException(200);
        } else
        {
            sendMarker(1);
            mkPkt = null;
            return;
        }
    }

    private void sendMarker(int i)
        throws IOException, NetException
    {
        if(i == 1)
            mkPkt = new MarkerPacket(sAtts);
        else
            mkPkt = new MarkerPacket(sAtts, i);
        mkPkt.send();
    }

    public void sendReset()
        throws IOException, NetException
    {
        if(!sAtts.connected)
            throw new NetException(200);
        sendMarker(2);
        while(sAtts.onBreakReset) 
        {
            packet = new Packet(sAtts);
            packet.receive();
            if(packet.type == 12)
            {
                mkPkt = new MarkerPacket(packet);
                if(mkPkt.data == 2)
                    sAtts.onBreakReset = false;
            }
        }
        mkPkt = null;
    }

    private void setNetStreams()
        throws NetException, IOException
    {
        sAtts.nsOutputStream = new NetOutputStream(sAtts);
        sAtts.nsInputStream = new NetInputStream(sAtts);
    }

    public void setO3logSessionKey(byte abyte0[])
        throws NetException, NetException
    {
        if(abyte0 != null)
            sAtts.ano.setO3logSessionKey(abyte0);
    }

    private static final boolean ACTIVATE_ANO = true;
    private AddrResolution addrRes;
    private SessionAtts sAtts;
    private MarkerPacket mkPkt;
    private Packet packet;
}
