// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   CharacterSetUTF.java

package oracle.sql;

import java.sql.SQLException;

// Referenced classes of package oracle.sql:
//            CharacterSet, CharacterBuffer, CharacterRepConstants, CharacterWalker

class CharacterSetUTF extends CharacterSet
    implements CharacterRepConstants
{

    CharacterSetUTF(int i)
    {
        super(i);
        super.rep = 2;
    }

    public byte[] convert(String s)
        throws SQLException
    {
        return CharacterSet.stringToUTF(s);
    }

    public byte[] convert(CharacterSet characterset, byte abyte0[], int i, int j)
        throws SQLException
    {
        byte abyte1[];
        if(characterset.rep == 2)
        {
            abyte1 = CharacterSet.useOrCopy(abyte0, i, j);
        } else
        {
            String s = characterset.toString(abyte0, i, j);
            abyte1 = CharacterSet.stringToUTF(s);
        }
        return abyte1;
    }

    public byte[] convertWithReplacement(String s)
    {
        return CharacterSet.stringToUTF(s);
    }

    int decode(CharacterWalker characterwalker)
        throws SQLException
    {
        byte abyte0[] = characterwalker.bytes;
        int j = characterwalker.next;
        int k = characterwalker.end;
        if(j >= k)
            CharacterSet.failUTFConversion();
        byte byte0 = abyte0[j++];
        int i = byte0 & 0xf0;
        char c;
        switch(i / 16)
        {
        case 0: // '\0'
        case 1: // '\001'
        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
            c = byte0;
            break;

        case 12: // '\f'
        case 13: // '\r'
            if(j >= k)
                CharacterSet.failUTFConversion();
            byte byte1 = abyte0[j++];
            if((byte1 & 0xc0) != 128)
                CharacterSet.failUTFConversion();
            c = (char)((byte0 & 0x1f) << 6 | byte1 & 0x3f);
            break;

        case 14: // '\016'
            if(j + 1 >= k)
                CharacterSet.failUTFConversion();
            byte byte2 = abyte0[j++];
            byte byte3 = abyte0[j++];
            if((byte2 & 0xc0) != 128 || (byte3 & 0xc0) != 128)
                CharacterSet.failUTFConversion();
            c = (char)((byte0 & 0xf) << 12 | (byte2 & 0x3f) << 6 | byte3 & 0x3f);
            break;

        case 8: // '\b'
        case 9: // '\t'
        case 10: // '\n'
        case 11: // '\013'
        default:
            CharacterSet.failUTFConversion();
            c = '\0';
            break;
        }
        characterwalker.next = j;
        return c;
    }

    void encode(CharacterBuffer characterbuffer, int i)
        throws SQLException
    {
        if(i > 65535)
        {
            CharacterSet.failUTFConversion();
        } else
        {
            CharacterSet.need(characterbuffer, 3);
            char ac[] = {
                (char)i
            };
            int j = CharacterSet.javaCharsToUTF(ac, 0, 1, characterbuffer.bytes, characterbuffer.next);
            characterbuffer.next += j;
        }
    }

    public boolean isConvertibleFrom(CharacterSet characterset)
    {
        boolean flag = characterset.rep <= 1024;
        return flag;
    }

    public boolean isLossyFrom(CharacterSet characterset)
    {
        return characterset.isUnicode() ^ true;
    }

    public boolean isUnicode()
    {
        return true;
    }

    public String toString(byte abyte0[], int i, int j)
        throws SQLException
    {
        return toStringWithReplacement(abyte0, i, j);
    }

    public String toStringWithReplacement(byte abyte0[], int i, int j)
    {
        char ac[];
        try
        {
            ac = CharacterSet.UTFToJavaChar(abyte0, i, j);
        }
        catch(SQLException _ex)
        {
            ac = (new char[] {
                '?', '?', '?'
            });
        }
        return new String(ac);
    }
}
