// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   LobDBAccessImpl.java

package oracle.sql;

import java.io.*;
import java.sql.Connection;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.*;

// Referenced classes of package oracle.sql:
//            BLOB, CLOB, BlobDBAccess, ClobDBAccess, 
//            BfileDBAccess, BFILE

public class LobDBAccessImpl
    implements BlobDBAccess, ClobDBAccess, BfileDBAccess
{

    public LobDBAccessImpl(OracleConnection oracleconnection)
        throws SQLException
    {
        if(oracleconnection == null)
            DBError.throwSqlException(68, "connection is null");
        m_conn = oracleconnection;
        m_dbaccess = oracleconnection.db_access;
    }

    public synchronized long length(BLOB blob)
        throws SQLException
    {
        return m_dbaccess.lobLength(blob);
    }

    public synchronized long position(BLOB blob, byte abyte0[], long l)
        throws SQLException
    {
        if(l < 1L)
            DBError.throwSqlException(68, "position()");
        long l1 = -1L;
        if(abyte0 != null && abyte0.length != 0)
        {
            long l2 = m_dbaccess.hasPattern(blob, abyte0, l);
            l1 = l2 != 0L ? l2 : -1L;
        }
        return l1;
    }

    public synchronized long position(BLOB blob, BLOB blob1, long l)
        throws SQLException
    {
        if(l < 1L)
            DBError.throwSqlException(68, "position()");
        long l1 = -1L;
        if(blob1 != null)
        {
            long l2 = m_dbaccess.isSubLob(blob, blob1, l);
            l1 = l2 != 0L ? l2 : -1L;
        }
        return l1;
    }

    public synchronized int getBytes(BLOB blob, long l, int i, byte abyte0[])
        throws SQLException
    {
        if(i < 0 || l < 1L || abyte0 == null)
            DBError.throwSqlException(68, "getBytes()");
        int j = 0;
        if(i != 0)
            j = (int)m_dbaccess.lobRead(blob, l, i, abyte0);
        return j;
    }

    public synchronized int putBytes(BLOB blob, long l, byte abyte0[], int i)
        throws SQLException
    {
        if(l < 1L)
            DBError.throwSqlException(68, "putBytes()");
        int j = 0;
        if(abyte0 == null || abyte0.length == 0 || i <= 0)
            j = 0;
        else
            j = (int)m_dbaccess.lobWrite(blob, l, abyte0, i);
        return j;
    }

    public synchronized int getChunkSize(BLOB blob)
        throws SQLException
    {
        return (int)m_dbaccess.getLobChunkSize(blob);
    }

    public synchronized void trim(BLOB blob, long l)
        throws SQLException
    {
        m_dbaccess.trimLob(blob.getConnection(), blob, 2004, l);
    }

    public synchronized BLOB createTemporaryBlob(Connection connection, boolean flag, int i)
        throws SQLException
    {
        return (BLOB)m_dbaccess.createTemporaryLob(connection, flag, i, 2004);
    }

    public synchronized void freeTemporary(BLOB blob)
        throws SQLException
    {
        m_dbaccess.freeTemporaryLob(blob.getConnection(), blob, 2004);
    }

    public synchronized boolean isTemporary(BLOB blob)
        throws SQLException
    {
        return m_dbaccess.isTemporaryLob(blob.getConnection(), blob, 2004);
    }

    public synchronized void open(BLOB blob, int i)
        throws SQLException
    {
        m_dbaccess.openLob(blob.getConnection(), blob, i, 2004);
    }

    public synchronized void close(BLOB blob)
        throws SQLException
    {
        m_dbaccess.closeLob(blob.getConnection(), blob, 2004);
    }

    public synchronized boolean isOpen(BLOB blob)
        throws SQLException
    {
        return m_dbaccess.isLobOpen(blob.getConnection(), blob, 2004);
    }

    public synchronized long length(CLOB clob)
        throws SQLException
    {
        return m_dbaccess.lobLength(clob);
    }

    public synchronized long position(CLOB clob, String s, long l)
        throws SQLException
    {
        if(l < 1L)
            DBError.check_error(68, "position()");
        long l1 = -1L;
        if(s != null && s.length() != 0)
        {
            long l2 = m_dbaccess.hasPattern(clob, s.toCharArray(), l);
            l1 = l2 != 0L ? l2 : -1L;
        }
        return l1;
    }

    public synchronized long position(CLOB clob, CLOB clob1, long l)
        throws SQLException
    {
        if(l < 1L)
            DBError.check_error(68, "position");
        long l1 = -1L;
        if(clob1 != null)
        {
            long l2 = m_dbaccess.isSubLob(clob, clob1, l);
            l1 = l2 != 0L ? l2 : -1L;
        }
        return l1;
    }

    public synchronized int getChars(CLOB clob, long l, int i, char ac[])
        throws SQLException
    {
        if(i < 0 || l < 1L || ac == null)
            DBError.check_error(68, "getChars()");
        int j = 0;
        if(i != 0)
            j = (int)m_dbaccess.lobRead(clob, l, i, ac);
        return j;
    }

    public synchronized int putChars(CLOB clob, long l, char ac[], int i)
        throws SQLException
    {
        if(l < 1L)
            DBError.check_error(68, "putChars()");
        int j = 0;
        if(ac == null || ac.length < 0 || i <= 0)
            j = 0;
        else
            j = (int)m_dbaccess.lobWrite(clob, l, ac, i);
        return j;
    }

    public synchronized int getChunkSize(CLOB clob)
        throws SQLException
    {
        return (int)m_dbaccess.getLobChunkSize(clob);
    }

    public synchronized void trim(CLOB clob, long l)
        throws SQLException
    {
        m_dbaccess.trimLob(clob.getConnection(), clob, 2005, l);
    }

    public synchronized CLOB createTemporaryClob(Connection connection, boolean flag, int i)
        throws SQLException
    {
        return (CLOB)m_dbaccess.createTemporaryLob(connection, flag, i, 2005);
    }

    public synchronized void freeTemporary(CLOB clob)
        throws SQLException
    {
        m_dbaccess.freeTemporaryLob(clob.getConnection(), clob, 2005);
    }

    public synchronized boolean isTemporary(CLOB clob)
        throws SQLException
    {
        return m_dbaccess.isTemporaryLob(clob.getConnection(), clob, 2005);
    }

    public synchronized void open(CLOB clob, int i)
        throws SQLException
    {
        m_dbaccess.openLob(clob.getConnection(), clob, i, 2005);
    }

    public synchronized void close(CLOB clob)
        throws SQLException
    {
        m_dbaccess.closeLob(clob.getConnection(), clob, 2005);
    }

    public synchronized boolean isOpen(CLOB clob)
        throws SQLException
    {
        return m_dbaccess.isLobOpen(clob.getConnection(), clob, 2005);
    }

    public synchronized long length(BFILE bfile)
        throws SQLException
    {
        return m_dbaccess.lobLength(bfile);
    }

    public synchronized int getBytes(BFILE bfile, long l, int i, byte abyte0[])
        throws SQLException
    {
        if(l < 1L || i < 0 || abyte0 == null)
            DBError.check_error(68, "getBytes()");
        int j = 0;
        if(i != 0)
            j = (int)m_dbaccess.lobRead(bfile, l, i, abyte0);
        return j;
    }

    public synchronized long position(BFILE bfile, byte abyte0[], long l)
        throws SQLException
    {
        if(l < 1L)
            DBError.check_error(68, "position()");
        long l1 = -1L;
        if(abyte0 != null && abyte0.length != 0)
        {
            long l2 = m_dbaccess.hasPattern(bfile, abyte0, l);
            l1 = l2 != 0L ? l2 : -1L;
        }
        return l1;
    }

    public synchronized long position(BFILE bfile, BFILE bfile1, long l)
        throws SQLException
    {
        if(l < 1L)
            DBError.check_error(68, "position()");
        long l1 = -1L;
        if(bfile1 != null)
        {
            long l2 = m_dbaccess.isSubLob(bfile, bfile1, l);
            l1 = l2 != 0L ? l2 : -1L;
        }
        return l1;
    }

    public synchronized String getName(BFILE bfile)
        throws SQLException
    {
        return m_dbaccess.fileGetName(bfile);
    }

    public synchronized String getDirAlias(BFILE bfile)
        throws SQLException
    {
        return m_dbaccess.fileGetDirAlias(bfile);
    }

    public synchronized void openFile(BFILE bfile)
        throws SQLException
    {
        m_dbaccess.fileOpen(bfile);
    }

    public synchronized boolean isFileOpen(BFILE bfile)
        throws SQLException
    {
        return m_dbaccess.fileIsOpen(bfile);
    }

    public synchronized boolean fileExists(BFILE bfile)
        throws SQLException
    {
        return m_dbaccess.fileExists(bfile);
    }

    public synchronized void closeFile(BFILE bfile)
        throws SQLException
    {
        m_dbaccess.fileClose(bfile);
    }

    public synchronized void open(BFILE bfile, int i)
        throws SQLException
    {
        m_dbaccess.openLob(bfile.getConnection(), bfile, i, -13);
    }

    public synchronized void close(BFILE bfile)
        throws SQLException
    {
        m_dbaccess.closeLob(bfile.getConnection(), bfile, -13);
    }

    public synchronized boolean isOpen(BFILE bfile)
        throws SQLException
    {
        return m_dbaccess.isLobOpen(bfile.getConnection(), bfile, -13);
    }

    public InputStream newInputStream(BFILE bfile, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleBlobInputStream(bfile, i);
        else
            return new OracleBlobInputStream(bfile, i, l);
    }

    public InputStream newConversionInputStream(BFILE bfile, int i)
        throws SQLException
    {
        OracleConversionInputStream oracleconversioninputstream = new OracleConversionInputStream(bfile.getConnection().conversion, bfile.getBinaryStream(), i);
        return oracleconversioninputstream;
    }

    public Reader newConversionReader(BFILE bfile, int i)
        throws SQLException
    {
        OracleConversionReader oracleconversionreader = new OracleConversionReader(bfile.getConnection().conversion, bfile.getBinaryStream(), i);
        return oracleconversionreader;
    }

    public InputStream newInputStream(BLOB blob, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleBlobInputStream(blob, i);
        else
            return new OracleBlobInputStream(blob, i, l);
    }

    public OutputStream newOutputStream(BLOB blob, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleBlobOutputStream(blob, i);
        else
            return new OracleBlobOutputStream(blob, i, l);
    }

    public InputStream newConversionInputStream(BLOB blob, int i)
        throws SQLException
    {
        OracleConversionInputStream oracleconversioninputstream = new OracleConversionInputStream(blob.getConnection().conversion, blob.getBinaryStream(), i);
        return oracleconversioninputstream;
    }

    public Reader newConversionReader(BLOB blob, int i)
        throws SQLException
    {
        OracleConversionReader oracleconversionreader = new OracleConversionReader(blob.getConnection().conversion, blob.getBinaryStream(), i);
        return oracleconversionreader;
    }

    public InputStream newInputStream(CLOB clob, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleClobInputStream(clob, i);
        else
            return new OracleClobInputStream(clob, i, l);
    }

    public OutputStream newOutputStream(CLOB clob, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleClobOutputStream(clob, i);
        else
            return new OracleClobOutputStream(clob, i, l);
    }

    public Reader newReader(CLOB clob, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleClobReader(clob, i);
        else
            return new OracleClobReader(clob, i, l);
    }

    public Writer newWriter(CLOB clob, int i, long l)
        throws SQLException
    {
        if(l == 0L)
            return new OracleClobWriter(clob, i);
        else
            return new OracleClobWriter(clob, i, l);
    }

    OracleConnection m_conn;
    DBAccess m_dbaccess;
}
